/* baobab-window.c generated by valac 0.56.4, the Vala compiler
 * generated from baobab-window.vala, do not modify */

/* -*- tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/* Baobab - disk usage analyzer
 *
 * Copyright (C) 2012  Ryan Lortie <desrt@desrt.ca>
 * Copyright (C) 2012  Paolo Borelli <pborelli@gnome.org>
 * Copyright (C) 2012  Stefano Facchini <stefano.facchini@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#include "baobab.h"
#include <gtk/gtk.h>
#include <adwaita.h>
#include <glib.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include "config.h"

enum  {
	BAOBAB_WINDOW_0_PROPERTY,
	BAOBAB_WINDOW_NUM_PROPERTIES
};
static GParamSpec* baobab_window_properties[BAOBAB_WINDOW_NUM_PROPERTIES];
#define _baobab_location_unref0(var) ((var == NULL) ? NULL : (var = (baobab_location_unref (var), NULL)))
typedef struct _Block6Data Block6Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block7Data Block7Data;
typedef struct _Block8Data Block8Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
typedef struct _Block9Data Block9Data;

struct _BaobabWindowPrivate {
	GtkEventControllerFocus* focus_controller;
	GtkDropTarget* drop_target;
	GtkGestureClick* back_gesture;
	GtkBox* vbox;
	AdwHeaderBar* header_bar;
	BaobabPathbar* pathbar;
	GtkButton* back_button;
	GtkButton* reload_button;
	GtkMenuButton* menu_button;
	GtkStack* main_stack;
	GtkWidget* home_page;
	GtkWidget* result_page;
	GtkInfoBar* infobar;
	GtkLabel* infobar_primary_label;
	GtkLabel* infobar_secondary_label;
	GtkButton* infobar_close_button;
	BaobabLocationList* location_list;
	BaobabFolderDisplay* folder_display;
	GtkTreeView* treeview;
	GtkPopoverMenu* treeview_popover_menu;
	GtkTreeViewColumn* size_column;
	GtkTreeViewColumn* contents_column;
	GtkTreeViewColumn* time_modified_column;
	GtkGestureClick* treeview_right_click_gesture;
	GtkStack* chart_stack;
	GtkStack* spinner_stack;
	GtkStackSwitcher* chart_stack_switcher;
	BaobabChart* rings_chart;
	BaobabChart* treemap_chart;
	GtkSpinner* spinner;
	BaobabLocation* active_location;
	gboolean is_busy;
	gulong scan_completed_handler;
	guint scanning_progress_id;
};

struct _Block6Data {
	int _ref_count_;
	BaobabWindow* self;
	GSettings* ui_settings;
};

struct _Block7Data {
	int _ref_count_;
	BaobabWindow* self;
	GtkFileChooserNative* file_chooser;
};

struct _Block8Data {
	int _ref_count_;
	BaobabWindow* self;
	BaobabLocation* location;
};

struct _Block9Data {
	int _ref_count_;
	BaobabWindow* self;
	BaobabLocation* location;
};

static gint BaobabWindow_private_offset;
static gpointer baobab_window_parent_class = NULL;
static GdkCursor* baobab_window_busy_cursor;
static GdkCursor* baobab_window_busy_cursor = NULL;

static void baobab_window_on_show_primary_menu_activate (BaobabWindow* self,
                                                  GSimpleAction* action);
static void _baobab_window_on_show_primary_menu_activate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                    GVariant* parameter,
                                                                                    gpointer self);
static void baobab_window_on_show_home_page_activate (BaobabWindow* self);
static void _baobab_window_on_show_home_page_activate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                 GVariant* parameter,
                                                                                 gpointer self);
static void baobab_window_on_scan_folder_activate (BaobabWindow* self);
static void _baobab_window_on_scan_folder_activate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self);
static void baobab_window_on_reload_activate (BaobabWindow* self);
static void _baobab_window_on_reload_activate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self);
static void baobab_window_on_clear_recent (BaobabWindow* self);
static void _baobab_window_on_clear_recent_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self);
static void baobab_window_on_show_preferences (BaobabWindow* self);
static void _baobab_window_on_show_preferences_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self);
static void baobab_window_on_help_activate (BaobabWindow* self);
static void _baobab_window_on_help_activate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self);
static void baobab_window_on_about_activate (BaobabWindow* self);
static void _baobab_window_on_about_activate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self);
static void baobab_window_on_show_treeview_popover (BaobabWindow* self);
static void _baobab_window_on_show_treeview_popover_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self);
static void baobab_window_on_treeview_expand_row (BaobabWindow* self);
static void _baobab_window_on_treeview_expand_row_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self);
static void baobab_window_on_treeview_collapse_row (BaobabWindow* self);
static void _baobab_window_on_treeview_collapse_row_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self);
static void baobab_window_go_up_treeview (BaobabWindow* self);
static void _baobab_window_go_up_treeview_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self);
static void baobab_window_on_treeview_open_folder (BaobabWindow* self);
static void _baobab_window_on_treeview_open_folder_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self);
static void baobab_window_on_treeview_copy (BaobabWindow* self);
static void _baobab_window_on_treeview_copy_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self);
static void baobab_window_on_treeview_trash (BaobabWindow* self);
static void _baobab_window_on_treeview_trash_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void baobab_window_location_activated (BaobabWindow* self,
                                       BaobabLocation* location);
static void _baobab_window_location_activated_baobab_location_list_location_activated (BaobabLocationList* _sender,
                                                                                BaobabLocation* location,
                                                                                gpointer self);
static void baobab_window_setup_treeview (BaobabWindow* self);
static void __lambda25_ (BaobabWindow* self);
static void baobab_window_clear_message (BaobabWindow* self);
static void ___lambda25__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda26_ (BaobabWindow* self);
static void ___lambda26__gtk_widget_destroy (GtkWidget* _sender,
                                      gpointer self);
static void baobab_window_on_chart_item_activated (BaobabWindow* self,
                                            BaobabChart* chart,
                                            GtkTreeIter* iter);
static void _baobab_window_on_chart_item_activated_baobab_chart_item_activated (BaobabChart* _sender,
                                                                         GtkTreeIter* iter,
                                                                         gpointer self);
static void baobab_window_on_pathbar_item_activated (BaobabWindow* self,
                                              BaobabPathbar* pathbar,
                                              GtkTreePath* path);
static void _baobab_window_on_pathbar_item_activated_baobab_pathbar_item_activated (BaobabPathbar* _sender,
                                                                             GtkTreePath* path,
                                                                             gpointer self);
static void baobab_window_on_folder_display_activated (BaobabWindow* self);
static void _baobab_window_on_folder_display_activated_baobab_folder_display_activated (BaobabFolderDisplay* _sender,
                                                                                 gpointer self);
static gboolean baobab_window_on_drop (BaobabWindow* self,
                                GtkDropTarget* target,
                                GValue* value,
                                gdouble x,
                                gdouble y);
static gboolean _baobab_window_on_drop_gtk_drop_target_drop (GtkDropTarget* _sender,
                                                      GValue* value,
                                                      gdouble x,
                                                      gdouble y,
                                                      gpointer self);
static gboolean baobab_window_on_drop_target_accept (BaobabWindow* self,
                                              GtkDropTarget* target,
                                              GdkDrop* drop);
static gboolean _baobab_window_on_drop_target_accept_gtk_drop_target_accept (GtkDropTarget* _sender,
                                                                      GdkDrop* drop,
                                                                      gpointer self);
static gboolean __lambda27_ (Block6Data* _data6_);
static gboolean ___lambda27__gtk_window_close_request (GtkWindow* _sender,
                                                gpointer self);
static void baobab_window_set_ui_state (BaobabWindow* self,
                                 GtkWidget* child,
                                 gboolean busy);
static void __lambda28_ (BaobabWindow* self,
                  gint n_press,
                  gdouble x,
                  gdouble y);
static void ___lambda28__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                             gint n_press,
                                             gdouble x,
                                             gdouble y,
                                             gpointer self);
static void __lambda29_ (BaobabWindow* self);
static void ___lambda29__gtk_event_controller_focus_enter (GtkEventControllerFocus* _sender,
                                                    gpointer self);
static void baobab_window_cancel_scan (BaobabWindow* self);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void __lambda16_ (Block7Data* _data7_,
                  gint response);
static void ___lambda16__gtk_native_dialog_response (GtkNativeDialog* _sender,
                                              gint response_id,
                                              gpointer self);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void baobab_window_set_busy (BaobabWindow* self,
                             gboolean busy);
static void __lambda22_ (Block8Data* _data8_,
                  GObject* location_,
                  GAsyncResult* res);
static void baobab_window_scan_location (BaobabWindow* self,
                                  BaobabLocation* location,
                                  gboolean force);
static void baobab_window_message (BaobabWindow* self,
                            const gchar* primary_msg,
                            const gchar* secondary_msg,
                            GtkMessageType type);
static void ___lambda22__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static gchar** _vala_array_dup2 (gchar** self,
                          gssize length);
static void baobab_window_reroot_treeview (BaobabWindow* self,
                                    GtkTreePath* path,
                                    gboolean select_first);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static GtkTreePath* _vala_GtkTreePath_copy (GtkTreePath* self);
static GtkTreePath* baobab_window_convert_child_path_to_path (BaobabWindow* self,
                                                       GtkTreePath* path);
static gboolean baobab_window_show_treeview_popover (BaobabWindow* self,
                                              GtkPopoverMenu* popover,
                                              gint x,
                                              gint y);
static gboolean baobab_window_get_selected_iter (BaobabWindow* self,
                                          GtkTreeIter* iter);
static void baobab_window_convert_iter_to_child_iter (BaobabWindow* self,
                                               GtkTreeIter* child_iter,
                                               GtkTreeIter* iter);
static GtkTreePath* baobab_window_convert_path_to_child_path (BaobabWindow* self,
                                                       GtkTreePath* path);
static void __lambda23_ (BaobabWindow* self,
                  gint n_press,
                  gdouble x,
                  gdouble y);
static void ___lambda23__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                             gint n_press,
                                             gdouble x,
                                             gdouble y,
                                             gpointer self);
static void __lambda24_ (BaobabWindow* self,
                  GtkTreePath* wrapper_path,
                  GtkTreeViewColumn* column);
static void ___lambda24__gtk_tree_view_row_activated (GtkTreeView* _sender,
                                               GtkTreePath* path,
                                               GtkTreeViewColumn* column,
                                               gpointer self);
static void baobab_window_reset_treeview_sorting (BaobabWindow* self);
static void _baobab_window_reset_treeview_sorting_gtk_tree_sortable_sort_column_changed (GtkTreeSortable* _sender,
                                                                                  gpointer self);
static void baobab_window_copy_treeview_column_sizes (BaobabWindow* self);
static void _baobab_window_copy_treeview_column_sizes_g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self);
static void baobab_window_set_chart_location (BaobabWindow* self,
                                       BaobabLocation* location);
static void baobab_window_scanner_completed (BaobabWindow* self);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void _baobab_window_scanner_completed_baobab_scanner_completed (BaobabScanner* _sender,
                                                                gpointer self);
static gboolean __lambda17_ (Block9Data* _data9_);
static gboolean ___lambda17__gsource_func (gpointer self);
static void baobab_window_finalize (GObject * obj);
static GType baobab_window_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const GActionEntry BAOBAB_WINDOW_action_entries[15] = {{"show-primary-menu", _baobab_window_on_show_primary_menu_activate_gsimple_action_activate_callback, NULL, "false", NULL}, {"show-home-page", _baobab_window_on_show_home_page_activate_gsimple_action_activate_callback}, {"scan-folder", _baobab_window_on_scan_folder_activate_gsimple_action_activate_callback}, {"reload", _baobab_window_on_reload_activate_gsimple_action_activate_callback}, {"clear-recent", _baobab_window_on_clear_recent_gsimple_action_activate_callback}, {"show-preferences", _baobab_window_on_show_preferences_gsimple_action_activate_callback}, {"help", _baobab_window_on_help_activate_gsimple_action_activate_callback}, {"about", _baobab_window_on_about_activate_gsimple_action_activate_callback}, {"show-treeview-popover", _baobab_window_on_show_treeview_popover_gsimple_action_activate_callback}, {"treeview-expand-row", _baobab_window_on_treeview_expand_row_gsimple_action_activate_callback}, {"treeview-collapse-row", _baobab_window_on_treeview_collapse_row_gsimple_action_activate_callback}, {"treeview-go-up", _baobab_window_go_up_treeview_gsimple_action_activate_callback}, {"treeview-open-folder", _baobab_window_on_treeview_open_folder_gsimple_action_activate_callback}, {"treeview-copy", _baobab_window_on_treeview_copy_gsimple_action_activate_callback}, {"treeview-trash", _baobab_window_on_treeview_trash_gsimple_action_activate_callback}};
static const BaobabWindowActionState BAOBAB_WINDOW_actions_while_scanning[1] = {{"scan-folder", FALSE}};

static inline gpointer
baobab_window_get_instance_private (BaobabWindow* self)
{
	return G_STRUCT_MEMBER_P (self, BaobabWindow_private_offset);
}

static void
_baobab_window_on_show_primary_menu_activate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self)
{
#line 95 "../src/baobab-window.vala"
	baobab_window_on_show_primary_menu_activate ((BaobabWindow*) self, action);
#line 350 "baobab-window.c"
}

static void
_baobab_window_on_show_home_page_activate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                            GVariant* parameter,
                                                                            gpointer self)
{
#line 95 "../src/baobab-window.vala"
	baobab_window_on_show_home_page_activate ((BaobabWindow*) self);
#line 360 "baobab-window.c"
}

static void
_baobab_window_on_scan_folder_activate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self)
{
#line 95 "../src/baobab-window.vala"
	baobab_window_on_scan_folder_activate ((BaobabWindow*) self);
#line 370 "baobab-window.c"
}

static void
_baobab_window_on_reload_activate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self)
{
#line 95 "../src/baobab-window.vala"
	baobab_window_on_reload_activate ((BaobabWindow*) self);
#line 380 "baobab-window.c"
}

static void
_baobab_window_on_clear_recent_gsimple_action_activate_callback (GSimpleAction* action,
                                                                 GVariant* parameter,
                                                                 gpointer self)
{
#line 95 "../src/baobab-window.vala"
	baobab_window_on_clear_recent ((BaobabWindow*) self);
#line 390 "baobab-window.c"
}

static void
_baobab_window_on_show_preferences_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self)
{
#line 95 "../src/baobab-window.vala"
	baobab_window_on_show_preferences ((BaobabWindow*) self);
#line 400 "baobab-window.c"
}

static void
_baobab_window_on_help_activate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self)
{
#line 95 "../src/baobab-window.vala"
	baobab_window_on_help_activate ((BaobabWindow*) self);
#line 410 "baobab-window.c"
}

static void
_baobab_window_on_about_activate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self)
{
#line 95 "../src/baobab-window.vala"
	baobab_window_on_about_activate ((BaobabWindow*) self);
#line 420 "baobab-window.c"
}

static void
_baobab_window_on_show_treeview_popover_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self)
{
#line 95 "../src/baobab-window.vala"
	baobab_window_on_show_treeview_popover ((BaobabWindow*) self);
#line 430 "baobab-window.c"
}

static void
_baobab_window_on_treeview_expand_row_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self)
{
#line 95 "../src/baobab-window.vala"
	baobab_window_on_treeview_expand_row ((BaobabWindow*) self);
#line 440 "baobab-window.c"
}

static void
_baobab_window_on_treeview_collapse_row_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self)
{
#line 95 "../src/baobab-window.vala"
	baobab_window_on_treeview_collapse_row ((BaobabWindow*) self);
#line 450 "baobab-window.c"
}

static void
_baobab_window_go_up_treeview_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self)
{
#line 95 "../src/baobab-window.vala"
	baobab_window_go_up_treeview ((BaobabWindow*) self);
#line 460 "baobab-window.c"
}

static void
_baobab_window_on_treeview_open_folder_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self)
{
#line 95 "../src/baobab-window.vala"
	baobab_window_on_treeview_open_folder ((BaobabWindow*) self);
#line 470 "baobab-window.c"
}

static void
_baobab_window_on_treeview_copy_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self)
{
#line 95 "../src/baobab-window.vala"
	baobab_window_on_treeview_copy ((BaobabWindow*) self);
#line 480 "baobab-window.c"
}

static void
_baobab_window_on_treeview_trash_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self)
{
#line 95 "../src/baobab-window.vala"
	baobab_window_on_treeview_trash ((BaobabWindow*) self);
#line 490 "baobab-window.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 122 "../src/baobab-window.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 122 "../src/baobab-window.vala"
	return _data6_;
#line 500 "baobab-window.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 122 "../src/baobab-window.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 510 "baobab-window.c"
		BaobabWindow* self;
#line 122 "../src/baobab-window.vala"
		self = _data6_->self;
#line 122 "../src/baobab-window.vala"
		_g_object_unref0 (_data6_->ui_settings);
#line 122 "../src/baobab-window.vala"
		_g_object_unref0 (self);
#line 122 "../src/baobab-window.vala"
		g_slice_free (Block6Data, _data6_);
#line 520 "baobab-window.c"
	}
}

static void
_baobab_window_location_activated_baobab_location_list_location_activated (BaobabLocationList* _sender,
                                                                           BaobabLocation* location,
                                                                           gpointer self)
{
#line 136 "../src/baobab-window.vala"
	baobab_window_location_activated ((BaobabWindow*) self, location);
#line 531 "baobab-window.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 139 "../src/baobab-window.vala"
	return self ? g_object_ref (self) : NULL;
#line 539 "baobab-window.c"
}

static void
__lambda25_ (BaobabWindow* self)
{
#line 144 "../src/baobab-window.vala"
	baobab_window_clear_message (self);
#line 547 "baobab-window.c"
}

static void
___lambda25__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 144 "../src/baobab-window.vala"
	__lambda25_ ((BaobabWindow*) self);
#line 556 "baobab-window.c"
}

static void
__lambda26_ (BaobabWindow* self)
{
	GtkStack* _tmp0_;
#line 147 "../src/baobab-window.vala"
	_tmp0_ = self->priv->chart_stack;
#line 147 "../src/baobab-window.vala"
	g_settings_unbind ((GObject*) _tmp0_, "visible-child-name");
#line 567 "baobab-window.c"
}

static void
___lambda26__gtk_widget_destroy (GtkWidget* _sender,
                                 gpointer self)
{
#line 147 "../src/baobab-window.vala"
	__lambda26_ ((BaobabWindow*) self);
#line 576 "baobab-window.c"
}

static void
_baobab_window_on_chart_item_activated_baobab_chart_item_activated (BaobabChart* _sender,
                                                                    GtkTreeIter* iter,
                                                                    gpointer self)
{
#line 149 "../src/baobab-window.vala"
	baobab_window_on_chart_item_activated ((BaobabWindow*) self, _sender, iter);
#line 586 "baobab-window.c"
}

static void
_baobab_window_on_pathbar_item_activated_baobab_pathbar_item_activated (BaobabPathbar* _sender,
                                                                        GtkTreePath* path,
                                                                        gpointer self)
{
#line 151 "../src/baobab-window.vala"
	baobab_window_on_pathbar_item_activated ((BaobabWindow*) self, _sender, path);
#line 596 "baobab-window.c"
}

static void
_baobab_window_on_folder_display_activated_baobab_folder_display_activated (BaobabFolderDisplay* _sender,
                                                                            gpointer self)
{
#line 152 "../src/baobab-window.vala"
	baobab_window_on_folder_display_activated ((BaobabWindow*) self);
#line 605 "baobab-window.c"
}

static gboolean
_baobab_window_on_drop_gtk_drop_target_drop (GtkDropTarget* _sender,
                                             GValue* value,
                                             gdouble x,
                                             gdouble y,
                                             gpointer self)
{
	gboolean result;
	result = baobab_window_on_drop ((BaobabWindow*) self, _sender, value, x, y);
#line 156 "../src/baobab-window.vala"
	return result;
#line 619 "baobab-window.c"
}

static gboolean
_baobab_window_on_drop_target_accept_gtk_drop_target_accept (GtkDropTarget* _sender,
                                                             GdkDrop* drop,
                                                             gpointer self)
{
	gboolean result;
	result = baobab_window_on_drop_target_accept ((BaobabWindow*) self, _sender, drop);
#line 157 "../src/baobab-window.vala"
	return result;
#line 631 "baobab-window.c"
}

static gboolean
__lambda27_ (Block6Data* _data6_)
{
	BaobabWindow* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GSettings* _tmp5_;
	gboolean result;
#line 170 "../src/baobab-window.vala"
	self = _data6_->self;
#line 171 "../src/baobab-window.vala"
	g_object_get ((GtkWindow*) self, "maximized", &_tmp0_, NULL);
#line 171 "../src/baobab-window.vala"
	_tmp1_ = _tmp0_;
#line 171 "../src/baobab-window.vala"
	if (!_tmp1_) {
#line 650 "baobab-window.c"
		gint win_width = 0;
		gint win_height = 0;
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
		GSettings* _tmp4_;
#line 173 "../src/baobab-window.vala"
		gtk_window_get_default_size ((GtkWindow*) self, &_tmp2_, &_tmp3_);
#line 173 "../src/baobab-window.vala"
		win_width = _tmp2_;
#line 173 "../src/baobab-window.vala"
		win_height = _tmp3_;
#line 174 "../src/baobab-window.vala"
		_tmp4_ = _data6_->ui_settings;
#line 174 "../src/baobab-window.vala"
		g_settings_set (_tmp4_, "window-size", "(ii)", win_width, win_height);
#line 666 "baobab-window.c"
	}
#line 176 "../src/baobab-window.vala"
	_tmp5_ = _data6_->ui_settings;
#line 176 "../src/baobab-window.vala"
	g_settings_apply (_tmp5_);
#line 177 "../src/baobab-window.vala"
	result = FALSE;
#line 177 "../src/baobab-window.vala"
	return result;
#line 676 "baobab-window.c"
}

static gboolean
___lambda27__gtk_window_close_request (GtkWindow* _sender,
                                       gpointer self)
{
	gboolean result;
	result = __lambda27_ (self);
#line 170 "../src/baobab-window.vala"
	return result;
#line 687 "baobab-window.c"
}

static void
__lambda28_ (BaobabWindow* self,
             gint n_press,
             gdouble x,
             gdouble y)
{
	GAction* _tmp0_;
#line 183 "../src/baobab-window.vala"
	_tmp0_ = g_action_map_lookup_action ((GActionMap*) self, "show-home-page");
#line 183 "../src/baobab-window.vala"
	g_action_activate (_tmp0_, NULL);
#line 701 "baobab-window.c"
}

static void
___lambda28__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                        gint n_press,
                                        gdouble x,
                                        gdouble y,
                                        gpointer self)
{
#line 182 "../src/baobab-window.vala"
	__lambda28_ ((BaobabWindow*) self, n_press, x, y);
#line 713 "baobab-window.c"
}

static void
__lambda29_ (BaobabWindow* self)
{
	GtkApplication* _tmp0_;
	GtkApplication* _tmp1_;
#line 187 "../src/baobab-window.vala"
	_tmp0_ = gtk_window_get_application ((GtkWindow*) self);
#line 187 "../src/baobab-window.vala"
	_tmp1_ = _tmp0_;
#line 187 "../src/baobab-window.vala"
	g_application_withdraw_notification ((GApplication*) _tmp1_, "scan-completed");
#line 727 "baobab-window.c"
}

static void
___lambda29__gtk_event_controller_focus_enter (GtkEventControllerFocus* _sender,
                                               gpointer self)
{
#line 186 "../src/baobab-window.vala"
	__lambda29_ ((BaobabWindow*) self);
#line 736 "baobab-window.c"
}

BaobabWindow*
baobab_window_construct (GType object_type,
                         BaobabApplication* app)
{
	BaobabWindow * self = NULL;
	Block6Data* _data6_;
	GdkCursor* _tmp0_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GAction* action = NULL;
	GSettings* _tmp4_;
	GAction* _tmp5_;
	GAction* _tmp6_;
	BaobabLocationList* _tmp7_;
	GtkBuilder* builder = NULL;
	GtkBuilder* _tmp8_;
	GMenuModel* treeview_menu = NULL;
	GtkBuilder* _tmp9_;
	GObject* _tmp10_;
	GMenuModel* _tmp11_;
	GtkPopoverMenu* _tmp12_;
	GMenuModel* _tmp13_;
	GtkButton* _tmp14_;
	GSettings* _tmp15_;
	GtkStack* _tmp16_;
	GtkStack* _tmp17_;
	BaobabChart* _tmp18_;
	BaobabChart* _tmp19_;
	BaobabPathbar* _tmp20_;
	BaobabFolderDisplay* _tmp21_;
	GtkDropTarget* _tmp22_;
	GType* _tmp23_;
	GType* _tmp24_;
	gint _tmp24__length1;
	GtkDropTarget* _tmp25_;
	GtkDropTarget* _tmp26_;
	GSettings* _tmp27_;
	gint width = 0;
	gint height = 0;
	GSettings* _tmp28_;
	gint _tmp29_ = 0;
	gint _tmp30_ = 0;
	GSettings* _tmp31_;
	GtkWidget* _tmp32_;
	GtkGestureClick* _tmp33_;
	GtkEventControllerFocus* _tmp34_;
#line 122 "../src/baobab-window.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 122 "../src/baobab-window.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 122 "../src/baobab-window.vala"
	_data6_->_ref_count_ = 1;
#line 123 "../src/baobab-window.vala"
	self = (BaobabWindow*) g_object_new (object_type, "application", app, NULL);
#line 123 "../src/baobab-window.vala"
	_data6_->self = g_object_ref (self);
#line 125 "../src/baobab-window.vala"
	_tmp0_ = baobab_window_busy_cursor;
#line 125 "../src/baobab-window.vala"
	if (_tmp0_ == NULL) {
#line 799 "baobab-window.c"
		GdkCursor* _tmp1_;
#line 126 "../src/baobab-window.vala"
		_tmp1_ = gdk_cursor_new_from_name ("wait", NULL);
#line 126 "../src/baobab-window.vala"
		_g_object_unref0 (baobab_window_busy_cursor);
#line 126 "../src/baobab-window.vala"
		baobab_window_busy_cursor = _tmp1_;
#line 807 "baobab-window.c"
	}
#line 129 "../src/baobab-window.vala"
	_tmp2_ = g_settings_new ("org.gnome.baobab.ui");
#line 129 "../src/baobab-window.vala"
	_data6_->ui_settings = _tmp2_;
#line 130 "../src/baobab-window.vala"
	_tmp3_ = _data6_->ui_settings;
#line 130 "../src/baobab-window.vala"
	g_settings_delay (_tmp3_);
#line 132 "../src/baobab-window.vala"
	g_action_map_add_action_entries ((GActionMap*) self, BAOBAB_WINDOW_action_entries, (gint) G_N_ELEMENTS (BAOBAB_WINDOW_action_entries), self);
#line 133 "../src/baobab-window.vala"
	_tmp4_ = _data6_->ui_settings;
#line 133 "../src/baobab-window.vala"
	_tmp5_ = g_settings_create_action (_tmp4_, "active-chart");
#line 133 "../src/baobab-window.vala"
	action = _tmp5_;
#line 134 "../src/baobab-window.vala"
	_tmp6_ = action;
#line 134 "../src/baobab-window.vala"
	g_action_map_add_action ((GActionMap*) self, _tmp6_);
#line 136 "../src/baobab-window.vala"
	_tmp7_ = self->priv->location_list;
#line 136 "../src/baobab-window.vala"
	g_signal_connect_object (_tmp7_, "location-activated", (GCallback) _baobab_window_location_activated_baobab_location_list_location_activated, self, 0);
#line 138 "../src/baobab-window.vala"
	_tmp8_ = gtk_builder_new_from_resource ("/org/gnome/baobab/ui/baobab-treeview-menu.ui");
#line 138 "../src/baobab-window.vala"
	builder = _tmp8_;
#line 139 "../src/baobab-window.vala"
	_tmp9_ = builder;
#line 139 "../src/baobab-window.vala"
	_tmp10_ = gtk_builder_get_object (_tmp9_, "treeview_menu");
#line 139 "../src/baobab-window.vala"
	_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, g_menu_model_get_type (), GMenuModel));
#line 139 "../src/baobab-window.vala"
	treeview_menu = _tmp11_;
#line 141 "../src/baobab-window.vala"
	baobab_window_setup_treeview (self);
#line 142 "../src/baobab-window.vala"
	_tmp12_ = self->priv->treeview_popover_menu;
#line 142 "../src/baobab-window.vala"
	_tmp13_ = treeview_menu;
#line 142 "../src/baobab-window.vala"
	gtk_popover_menu_set_menu_model (_tmp12_, _tmp13_);
#line 144 "../src/baobab-window.vala"
	_tmp14_ = self->priv->infobar_close_button;
#line 144 "../src/baobab-window.vala"
	g_signal_connect_object (_tmp14_, "clicked", (GCallback) ___lambda25__gtk_button_clicked, self, 0);
#line 146 "../src/baobab-window.vala"
	_tmp15_ = _data6_->ui_settings;
#line 146 "../src/baobab-window.vala"
	_tmp16_ = self->priv->chart_stack;
#line 146 "../src/baobab-window.vala"
	g_settings_bind (_tmp15_, "active-chart", (GObject*) _tmp16_, "visible-child-name", G_SETTINGS_BIND_DEFAULT);
#line 147 "../src/baobab-window.vala"
	_tmp17_ = self->priv->chart_stack;
#line 147 "../src/baobab-window.vala"
	g_signal_connect_object ((GtkWidget*) _tmp17_, "destroy", (GCallback) ___lambda26__gtk_widget_destroy, self, 0);
#line 149 "../src/baobab-window.vala"
	_tmp18_ = self->priv->rings_chart;
#line 149 "../src/baobab-window.vala"
	g_signal_connect_object (_tmp18_, "item-activated", (GCallback) _baobab_window_on_chart_item_activated_baobab_chart_item_activated, self, 0);
#line 150 "../src/baobab-window.vala"
	_tmp19_ = self->priv->treemap_chart;
#line 150 "../src/baobab-window.vala"
	g_signal_connect_object (_tmp19_, "item-activated", (GCallback) _baobab_window_on_chart_item_activated_baobab_chart_item_activated, self, 0);
#line 151 "../src/baobab-window.vala"
	_tmp20_ = self->priv->pathbar;
#line 151 "../src/baobab-window.vala"
	g_signal_connect_object (_tmp20_, "item-activated", (GCallback) _baobab_window_on_pathbar_item_activated_baobab_pathbar_item_activated, self, 0);
#line 152 "../src/baobab-window.vala"
	_tmp21_ = self->priv->folder_display;
#line 152 "../src/baobab-window.vala"
	g_signal_connect_object (_tmp21_, "activated", (GCallback) _baobab_window_on_folder_display_activated_baobab_folder_display_activated, self, 0);
#line 155 "../src/baobab-window.vala"
	_tmp22_ = self->priv->drop_target;
#line 155 "../src/baobab-window.vala"
	_tmp23_ = g_new0 (GType, 1);
#line 155 "../src/baobab-window.vala"
	_tmp23_[0] = gdk_file_list_get_type ();
#line 155 "../src/baobab-window.vala"
	_tmp24_ = _tmp23_;
#line 155 "../src/baobab-window.vala"
	_tmp24__length1 = 1;
#line 155 "../src/baobab-window.vala"
	gtk_drop_target_set_gtypes (_tmp22_, _tmp24_, (gsize) 1);
#line 155 "../src/baobab-window.vala"
	_tmp24_ = (g_free (_tmp24_), NULL);
#line 156 "../src/baobab-window.vala"
	_tmp25_ = self->priv->drop_target;
#line 156 "../src/baobab-window.vala"
	g_signal_connect_object (_tmp25_, "drop", (GCallback) _baobab_window_on_drop_gtk_drop_target_drop, self, 0);
#line 157 "../src/baobab-window.vala"
	_tmp26_ = self->priv->drop_target;
#line 157 "../src/baobab-window.vala"
	g_signal_connect_object (_tmp26_, "accept", (GCallback) _baobab_window_on_drop_target_accept_gtk_drop_target_accept, self, 0);
#line 160 "../src/baobab-window.vala"
	_tmp27_ = _data6_->ui_settings;
#line 160 "../src/baobab-window.vala"
	if (g_settings_get_boolean (_tmp27_, "is-maximized")) {
#line 161 "../src/baobab-window.vala"
		gtk_window_maximize ((GtkWindow*) self);
#line 911 "baobab-window.c"
	}
#line 165 "../src/baobab-window.vala"
	_tmp28_ = _data6_->ui_settings;
#line 165 "../src/baobab-window.vala"
	g_settings_get (_tmp28_, "window-size", "(ii)", &_tmp29_, &_tmp30_);
#line 165 "../src/baobab-window.vala"
	width = _tmp29_;
#line 165 "../src/baobab-window.vala"
	height = _tmp30_;
#line 166 "../src/baobab-window.vala"
	gtk_window_set_default_size ((GtkWindow*) self, width, height);
#line 168 "../src/baobab-window.vala"
	_tmp31_ = _data6_->ui_settings;
#line 168 "../src/baobab-window.vala"
	g_settings_bind (_tmp31_, "is-maximized", (GObject*) self, "maximized", G_SETTINGS_BIND_SET);
#line 170 "../src/baobab-window.vala"
	g_signal_connect_data ((GtkWindow*) self, "close-request", (GCallback) ___lambda27__gtk_window_close_request, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 180 "../src/baobab-window.vala"
	_tmp32_ = self->priv->home_page;
#line 180 "../src/baobab-window.vala"
	baobab_window_set_ui_state (self, _tmp32_, FALSE);
#line 182 "../src/baobab-window.vala"
	_tmp33_ = self->priv->back_gesture;
#line 182 "../src/baobab-window.vala"
	g_signal_connect_object (_tmp33_, "pressed", (GCallback) ___lambda28__gtk_gesture_click_pressed, self, 0);
#line 186 "../src/baobab-window.vala"
	_tmp34_ = self->priv->focus_controller;
#line 186 "../src/baobab-window.vala"
	g_signal_connect_object (_tmp34_, "enter", (GCallback) ___lambda29__gtk_event_controller_focus_enter, self, 0);
#line 190 "../src/baobab-window.vala"
	gtk_window_present ((GtkWindow*) self);
#line 122 "../src/baobab-window.vala"
	_g_object_unref0 (treeview_menu);
#line 122 "../src/baobab-window.vala"
	_g_object_unref0 (builder);
#line 122 "../src/baobab-window.vala"
	_g_object_unref0 (action);
#line 122 "../src/baobab-window.vala"
	block6_data_unref (_data6_);
#line 122 "../src/baobab-window.vala"
	_data6_ = NULL;
#line 122 "../src/baobab-window.vala"
	return self;
#line 955 "baobab-window.c"
}

BaobabWindow*
baobab_window_new (BaobabApplication* app)
{
#line 122 "../src/baobab-window.vala"
	return baobab_window_construct (BAOBAB_TYPE_WINDOW, app);
#line 963 "baobab-window.c"
}

static void
baobab_window_on_show_primary_menu_activate (BaobabWindow* self,
                                             GSimpleAction* action)
{
	gboolean state = FALSE;
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	gboolean _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
#line 193 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 193 "../src/baobab-window.vala"
	g_return_if_fail (action != NULL);
#line 194 "../src/baobab-window.vala"
	_tmp0_ = g_action_get_state ((GAction*) action);
#line 194 "../src/baobab-window.vala"
	_tmp1_ = _tmp0_;
#line 194 "../src/baobab-window.vala"
	_tmp2_ = g_variant_get_boolean (_tmp1_);
#line 194 "../src/baobab-window.vala"
	_g_variant_unref0 (_tmp1_);
#line 194 "../src/baobab-window.vala"
	state = _tmp2_;
#line 195 "../src/baobab-window.vala"
	_tmp3_ = g_variant_new_boolean (!state);
#line 195 "../src/baobab-window.vala"
	g_variant_ref_sink (_tmp3_);
#line 195 "../src/baobab-window.vala"
	_tmp4_ = _tmp3_;
#line 195 "../src/baobab-window.vala"
	g_simple_action_set_state (action, _tmp4_);
#line 195 "../src/baobab-window.vala"
	_g_variant_unref0 (_tmp4_);
#line 1000 "baobab-window.c"
}

static void
baobab_window_on_show_home_page_activate (BaobabWindow* self)
{
	GtkWidget* _tmp0_;
#line 198 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 199 "../src/baobab-window.vala"
	baobab_window_cancel_scan (self);
#line 200 "../src/baobab-window.vala"
	baobab_window_clear_message (self);
#line 201 "../src/baobab-window.vala"
	_tmp0_ = self->priv->home_page;
#line 201 "../src/baobab-window.vala"
	baobab_window_set_ui_state (self, _tmp0_, FALSE);
#line 1017 "baobab-window.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 204 "../src/baobab-window.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 204 "../src/baobab-window.vala"
	return _data7_;
#line 1027 "baobab-window.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 204 "../src/baobab-window.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 1037 "baobab-window.c"
		BaobabWindow* self;
#line 204 "../src/baobab-window.vala"
		self = _data7_->self;
#line 204 "../src/baobab-window.vala"
		_g_object_unref0 (_data7_->file_chooser);
#line 204 "../src/baobab-window.vala"
		_g_object_unref0 (self);
#line 204 "../src/baobab-window.vala"
		g_slice_free (Block7Data, _data7_);
#line 1047 "baobab-window.c"
	}
}

static gboolean
bool_parse (const gchar* str)
{
	gboolean result;
#line 44 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 45 "glib-2.0.vapi"
	if (g_strcmp0 (str, "true") == 0) {
#line 46 "glib-2.0.vapi"
		result = TRUE;
#line 46 "glib-2.0.vapi"
		return result;
#line 1063 "baobab-window.c"
	} else {
#line 48 "glib-2.0.vapi"
		result = FALSE;
#line 48 "glib-2.0.vapi"
		return result;
#line 1069 "baobab-window.c"
	}
}

static void
__lambda16_ (Block7Data* _data7_,
             gint response)
{
	BaobabWindow* self;
#line 215 "../src/baobab-window.vala"
	self = _data7_->self;
#line 216 "../src/baobab-window.vala"
	if (response == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 1082 "baobab-window.c"
		gboolean recurse = FALSE;
		const gchar* _tmp0_;
		BaobabScanFlags _tmp1_ = 0U;
		BaobabScanFlags flags = 0U;
		GFile* _tmp2_;
		GFile* _tmp3_;
#line 217 "../src/baobab-window.vala"
		_tmp0_ = gtk_file_chooser_get_choice ((GtkFileChooser*) _data7_->file_chooser, "recurse");
#line 217 "../src/baobab-window.vala"
		recurse = bool_parse (_tmp0_);
#line 218 "../src/baobab-window.vala"
		if (recurse) {
#line 218 "../src/baobab-window.vala"
			_tmp1_ = BAOBAB_SCAN_FLAGS_NONE;
#line 1097 "baobab-window.c"
		} else {
#line 218 "../src/baobab-window.vala"
			_tmp1_ = BAOBAB_SCAN_FLAGS_EXCLUDE_MOUNTS;
#line 1101 "baobab-window.c"
		}
#line 218 "../src/baobab-window.vala"
		flags = _tmp1_;
#line 219 "../src/baobab-window.vala"
		_tmp2_ = gtk_file_chooser_get_file ((GtkFileChooser*) _data7_->file_chooser);
#line 219 "../src/baobab-window.vala"
		_tmp3_ = _tmp2_;
#line 219 "../src/baobab-window.vala"
		baobab_window_scan_directory (self, _tmp3_, flags);
#line 219 "../src/baobab-window.vala"
		_g_object_unref0 (_tmp3_);
#line 1113 "baobab-window.c"
	}
#line 221 "../src/baobab-window.vala"
	gtk_native_dialog_destroy ((GtkNativeDialog*) _data7_->file_chooser);
#line 1117 "baobab-window.c"
}

static void
___lambda16__gtk_native_dialog_response (GtkNativeDialog* _sender,
                                         gint response_id,
                                         gpointer self)
{
#line 215 "../src/baobab-window.vala"
	__lambda16_ (self, response_id);
#line 1127 "baobab-window.c"
}

static void
baobab_window_on_scan_folder_activate (BaobabWindow* self)
{
	Block7Data* _data7_;
	GtkFileChooserNative* _tmp0_;
#line 204 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 204 "../src/baobab-window.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 204 "../src/baobab-window.vala"
	_data7_->_ref_count_ = 1;
#line 204 "../src/baobab-window.vala"
	_data7_->self = g_object_ref (self);
#line 205 "../src/baobab-window.vala"
	_tmp0_ = gtk_file_chooser_native_new (_ ("Select Folder"), (GtkWindow*) self, GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER, NULL, NULL);
#line 205 "../src/baobab-window.vala"
	_data7_->file_chooser = _tmp0_;
#line 209 "../src/baobab-window.vala"
	gtk_native_dialog_set_modal ((GtkNativeDialog*) _data7_->file_chooser, TRUE);
#line 211 "../src/baobab-window.vala"
	gtk_file_chooser_add_choice ((GtkFileChooser*) _data7_->file_chooser, "recurse", _ ("Recursively analyze mount points"), NULL, NULL);
#line 215 "../src/baobab-window.vala"
	g_signal_connect_data ((GtkNativeDialog*) _data7_->file_chooser, "response", (GCallback) ___lambda16__gtk_native_dialog_response, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 224 "../src/baobab-window.vala"
	gtk_native_dialog_show ((GtkNativeDialog*) _data7_->file_chooser);
#line 204 "../src/baobab-window.vala"
	block7_data_unref (_data7_);
#line 204 "../src/baobab-window.vala"
	_data7_ = NULL;
#line 1159 "baobab-window.c"
}

static gpointer
_baobab_location_ref0 (gpointer self)
{
#line 227 "../src/baobab-window.vala"
	return self ? baobab_location_ref (self) : NULL;
#line 1167 "baobab-window.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 227 "../src/baobab-window.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 227 "../src/baobab-window.vala"
	return _data8_;
#line 1177 "baobab-window.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 227 "../src/baobab-window.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 1187 "baobab-window.c"
		BaobabWindow* self;
#line 227 "../src/baobab-window.vala"
		self = _data8_->self;
#line 227 "../src/baobab-window.vala"
		_baobab_location_unref0 (_data8_->location);
#line 227 "../src/baobab-window.vala"
		_g_object_unref0 (self);
#line 227 "../src/baobab-window.vala"
		g_slice_free (Block8Data, _data8_);
#line 1197 "baobab-window.c"
	}
}

static void
__lambda22_ (Block8Data* _data8_,
             GObject* location_,
             GAsyncResult* res)
{
	BaobabWindow* self;
	GError* _inner_error0_ = NULL;
#line 229 "../src/baobab-window.vala"
	self = _data8_->self;
#line 229 "../src/baobab-window.vala"
	g_return_if_fail (res != NULL);
#line 1212 "baobab-window.c"
	{
#line 231 "../src/baobab-window.vala"
		baobab_location_mount_volume_finish (_data8_->location, res, &_inner_error0_);
#line 231 "../src/baobab-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1218 "baobab-window.c"
			goto __catch0_g_error;
		}
#line 232 "../src/baobab-window.vala"
		baobab_window_scan_location (self, _data8_->location, FALSE);
#line 1223 "baobab-window.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 230 "../src/baobab-window.vala"
		e = _inner_error0_;
#line 230 "../src/baobab-window.vala"
		_inner_error0_ = NULL;
#line 234 "../src/baobab-window.vala"
		baobab_window_set_busy (self, FALSE);
#line 235 "../src/baobab-window.vala"
		_tmp0_ = e;
#line 235 "../src/baobab-window.vala"
		_tmp1_ = _tmp0_->message;
#line 235 "../src/baobab-window.vala"
		baobab_window_message (self, _ ("Could not analyze volume."), _tmp1_, GTK_MESSAGE_ERROR);
#line 230 "../src/baobab-window.vala"
		_g_error_free0 (e);
#line 1245 "baobab-window.c"
	}
	__finally0:
#line 230 "../src/baobab-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 230 "../src/baobab-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 230 "../src/baobab-window.vala"
		g_clear_error (&_inner_error0_);
#line 230 "../src/baobab-window.vala"
		return;
#line 1256 "baobab-window.c"
	}
}

static void
___lambda22__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 229 "../src/baobab-window.vala"
	__lambda22_ (self, source_object, res);
#line 229 "../src/baobab-window.vala"
	block8_data_unref (self);
#line 1269 "baobab-window.c"
}

static void
baobab_window_location_activated (BaobabWindow* self,
                                  BaobabLocation* location)
{
	Block8Data* _data8_;
	BaobabLocation* _tmp0_;
#line 227 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 227 "../src/baobab-window.vala"
	g_return_if_fail (location != NULL);
#line 227 "../src/baobab-window.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 227 "../src/baobab-window.vala"
	_data8_->_ref_count_ = 1;
#line 227 "../src/baobab-window.vala"
	_data8_->self = g_object_ref (self);
#line 227 "../src/baobab-window.vala"
	_tmp0_ = _baobab_location_ref0 (location);
#line 227 "../src/baobab-window.vala"
	_baobab_location_unref0 (_data8_->location);
#line 227 "../src/baobab-window.vala"
	_data8_->location = _tmp0_;
#line 228 "../src/baobab-window.vala"
	baobab_window_set_busy (self, TRUE);
#line 229 "../src/baobab-window.vala"
	baobab_location_mount_volume (_data8_->location, ___lambda22__gasync_ready_callback, block8_data_ref (_data8_));
#line 227 "../src/baobab-window.vala"
	block8_data_unref (_data8_);
#line 227 "../src/baobab-window.vala"
	_data8_ = NULL;
#line 1302 "baobab-window.c"
}

static void
baobab_window_on_reload_activate (BaobabWindow* self)
{
	BaobabLocation* _tmp0_;
#line 240 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 241 "../src/baobab-window.vala"
	_tmp0_ = self->priv->active_location;
#line 241 "../src/baobab-window.vala"
	baobab_window_scan_location (self, _tmp0_, TRUE);
#line 1315 "baobab-window.c"
}

static void
baobab_window_cancel_scan (BaobabWindow* self)
{
	gboolean _tmp0_ = FALSE;
	BaobabLocation* _tmp1_;
#line 244 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 245 "../src/baobab-window.vala"
	_tmp1_ = self->priv->active_location;
#line 245 "../src/baobab-window.vala"
	if (_tmp1_ != NULL) {
#line 1329 "baobab-window.c"
		BaobabLocation* _tmp2_;
		BaobabScanner* _tmp3_;
		BaobabScanner* _tmp4_;
#line 245 "../src/baobab-window.vala"
		_tmp2_ = self->priv->active_location;
#line 245 "../src/baobab-window.vala"
		_tmp3_ = baobab_location_get_scanner (_tmp2_);
#line 245 "../src/baobab-window.vala"
		_tmp4_ = _tmp3_;
#line 245 "../src/baobab-window.vala"
		_tmp0_ = _tmp4_ != NULL;
#line 1341 "baobab-window.c"
	} else {
#line 245 "../src/baobab-window.vala"
		_tmp0_ = FALSE;
#line 1345 "baobab-window.c"
	}
#line 245 "../src/baobab-window.vala"
	if (_tmp0_) {
#line 1349 "baobab-window.c"
		BaobabLocation* _tmp5_;
		BaobabScanner* _tmp6_;
		BaobabScanner* _tmp7_;
#line 246 "../src/baobab-window.vala"
		_tmp5_ = self->priv->active_location;
#line 246 "../src/baobab-window.vala"
		_tmp6_ = baobab_location_get_scanner (_tmp5_);
#line 246 "../src/baobab-window.vala"
		_tmp7_ = _tmp6_;
#line 246 "../src/baobab-window.vala"
		baobab_scanner_cancel (_tmp7_);
#line 1361 "baobab-window.c"
	}
#line 249 "../src/baobab-window.vala"
	if (self->priv->scan_completed_handler > ((gulong) 0)) {
#line 1365 "baobab-window.c"
		BaobabLocation* _tmp8_;
		BaobabScanner* _tmp9_;
		BaobabScanner* _tmp10_;
#line 250 "../src/baobab-window.vala"
		_tmp8_ = self->priv->active_location;
#line 250 "../src/baobab-window.vala"
		_tmp9_ = baobab_location_get_scanner (_tmp8_);
#line 250 "../src/baobab-window.vala"
		_tmp10_ = _tmp9_;
#line 250 "../src/baobab-window.vala"
		g_signal_handler_disconnect ((GObject*) _tmp10_, self->priv->scan_completed_handler);
#line 251 "../src/baobab-window.vala"
		self->priv->scan_completed_handler = (gulong) 0;
#line 1379 "baobab-window.c"
	}
#line 254 "../src/baobab-window.vala"
	_baobab_location_unref0 (self->priv->active_location);
#line 254 "../src/baobab-window.vala"
	self->priv->active_location = NULL;
#line 1385 "baobab-window.c"
}

static void
baobab_window_on_clear_recent (BaobabWindow* self)
{
	BaobabLocationList* _tmp0_;
#line 257 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 258 "../src/baobab-window.vala"
	_tmp0_ = self->priv->location_list;
#line 258 "../src/baobab-window.vala"
	baobab_location_list_clear_recent (_tmp0_, TRUE);
#line 1398 "baobab-window.c"
}

static void
baobab_window_on_show_preferences (BaobabWindow* self)
{
	BaobabPreferencesDialog* dialog = NULL;
	BaobabPreferencesDialog* _tmp0_;
#line 261 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 262 "../src/baobab-window.vala"
	_tmp0_ = baobab_preferences_dialog_new ();
#line 262 "../src/baobab-window.vala"
	g_object_ref_sink (_tmp0_);
#line 262 "../src/baobab-window.vala"
	dialog = _tmp0_;
#line 263 "../src/baobab-window.vala"
	gtk_window_set_modal ((GtkWindow*) dialog, TRUE);
#line 264 "../src/baobab-window.vala"
	gtk_window_set_transient_for ((GtkWindow*) dialog, (GtkWindow*) self);
#line 265 "../src/baobab-window.vala"
	gtk_window_present ((GtkWindow*) dialog);
#line 261 "../src/baobab-window.vala"
	_g_object_unref0 (dialog);
#line 1422 "baobab-window.c"
}

static void
baobab_window_on_help_activate (BaobabWindow* self)
{
#line 268 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 269 "../src/baobab-window.vala"
	gtk_show_uri ((GtkWindow*) self, "help:baobab", (guint32) GDK_CURRENT_TIME);
#line 1432 "baobab-window.c"
}

static gchar**
_vala_array_dup2 (gchar** self,
                  gssize length)
{
#line 286 "../src/baobab-window.vala"
	if (length >= 0) {
#line 1441 "baobab-window.c"
		gchar** result;
		gssize i;
#line 286 "../src/baobab-window.vala"
		result = g_new0 (gchar*, length + 1);
#line 286 "../src/baobab-window.vala"
		for (i = 0; i < length; i++) {
#line 1448 "baobab-window.c"
			gchar* _tmp0_;
#line 286 "../src/baobab-window.vala"
			_tmp0_ = g_strdup (self[i]);
#line 286 "../src/baobab-window.vala"
			result[i] = _tmp0_;
#line 1454 "baobab-window.c"
		}
#line 286 "../src/baobab-window.vala"
		return result;
#line 1458 "baobab-window.c"
	}
#line 286 "../src/baobab-window.vala"
	return NULL;
#line 1462 "baobab-window.c"
}

static void
baobab_window_on_about_activate (BaobabWindow* self)
{
#line 273 "../src/baobab-window.vala"
	static const gchar* developers[7] = {"Ryan Lortie <desrt@desrt.ca>", "Fabio Marzocca <thesaltydog@gmail.com>", "Paolo Borelli <pborelli@gnome.com>", "Stefano Facchini <stefano.facchini@gmail.com>", "Benoît Dejean <benoit@placenet.org>", "Igalia (rings-chart and treemap widget) <www.igalia.com>", NULL};
#line 283 "../src/baobab-window.vala"
	static const char copyright[] = "Copyright \xc2\xa9 2005-2011 Fabio Marzocca, Paolo Borelli, Benoît Dej" \
"ean, Igalia\n" "Copyright \xc2\xa9 2011-2012 Ryan Lortie, Paolo Borelli, Stefano Facch" \
"ini\n";
#line 1472 "baobab-window.c"
	AdwAboutWindow* about = NULL;
	GtkWindow* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar* _tmp9_;
	AdwAboutWindow* _tmp10_ = NULL;
#line 272 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 286 "../src/baobab-window.vala"
	_tmp0_ = _g_object_ref0 ((GtkWindow*) self);
#line 286 "../src/baobab-window.vala"
	_tmp1_ = g_strdup (_ ("Disk Usage Analyzer"));
#line 286 "../src/baobab-window.vala"
	_tmp2_ = g_strdup ("org.gnome.baobab");
#line 286 "../src/baobab-window.vala"
	_tmp3_ = g_strdup (_ ("The GNOME Project"));
#line 286 "../src/baobab-window.vala"
	_tmp4_ = g_strdup (VERSION);
#line 286 "../src/baobab-window.vala"
	_tmp5_ = g_strdup ("https://wiki.gnome.org/action/show/Apps/DiskUsageAnalyzer");
#line 286 "../src/baobab-window.vala"
	_tmp6_ = g_strdup ("https://gitlab.gnome.org/GNOME/baobab/-/issues/new");
#line 286 "../src/baobab-window.vala"
	_tmp7_ = g_strdup (copyright);
#line 286 "../src/baobab-window.vala"
	_tmp8_ = _vala_array_dup2 (developers, G_N_ELEMENTS (developers));
#line 286 "../src/baobab-window.vala"
	_tmp8__length1 = G_N_ELEMENTS (developers);
#line 286 "../src/baobab-window.vala"
	_tmp9_ = g_strdup (_ ("translator-credits"));
#line 286 "../src/baobab-window.vala"
	_tmp10_ = (AdwAboutWindow*) adw_about_window_new ();
#line 286 "../src/baobab-window.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp10_, _tmp0_);
#line 286 "../src/baobab-window.vala"
	_g_object_unref0 (_tmp0_);
#line 286 "../src/baobab-window.vala"
	adw_about_window_set_application_name (_tmp10_, _tmp1_);
#line 286 "../src/baobab-window.vala"
	_g_free0 (_tmp1_);
#line 286 "../src/baobab-window.vala"
	adw_about_window_set_application_icon (_tmp10_, _tmp2_);
#line 286 "../src/baobab-window.vala"
	_g_free0 (_tmp2_);
#line 286 "../src/baobab-window.vala"
	adw_about_window_set_developer_name (_tmp10_, _tmp3_);
#line 286 "../src/baobab-window.vala"
	_g_free0 (_tmp3_);
#line 286 "../src/baobab-window.vala"
	adw_about_window_set_version (_tmp10_, _tmp4_);
#line 286 "../src/baobab-window.vala"
	_g_free0 (_tmp4_);
#line 286 "../src/baobab-window.vala"
	adw_about_window_set_website (_tmp10_, _tmp5_);
#line 286 "../src/baobab-window.vala"
	_g_free0 (_tmp5_);
#line 286 "../src/baobab-window.vala"
	adw_about_window_set_issue_url (_tmp10_, _tmp6_);
#line 286 "../src/baobab-window.vala"
	_g_free0 (_tmp6_);
#line 286 "../src/baobab-window.vala"
	adw_about_window_set_copyright (_tmp10_, _tmp7_);
#line 286 "../src/baobab-window.vala"
	_g_free0 (_tmp7_);
#line 286 "../src/baobab-window.vala"
	adw_about_window_set_license_type (_tmp10_, GTK_LICENSE_GPL_2_0);
#line 286 "../src/baobab-window.vala"
	adw_about_window_set_developers (_tmp10_, _tmp8_);
#line 286 "../src/baobab-window.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 286 "../src/baobab-window.vala"
	adw_about_window_set_translator_credits (_tmp10_, _tmp9_);
#line 286 "../src/baobab-window.vala"
	_g_free0 (_tmp9_);
#line 286 "../src/baobab-window.vala"
	g_object_ref_sink (_tmp10_);
#line 286 "../src/baobab-window.vala"
	about = _tmp10_;
#line 300 "../src/baobab-window.vala"
	gtk_window_present ((GtkWindow*) about);
#line 272 "../src/baobab-window.vala"
	_g_object_unref0 (about);
#line 1562 "baobab-window.c"
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 303 "../src/baobab-window.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 1570 "baobab-window.c"
}

static void
baobab_window_on_chart_item_activated (BaobabWindow* self,
                                       BaobabChart* chart,
                                       GtkTreeIter* iter)
{
	GtkTreePath* path = NULL;
	BaobabLocation* _tmp0_;
	BaobabScanner* _tmp1_;
	BaobabScanner* _tmp2_;
	GtkTreeIter _tmp3_;
	GtkTreePath* _tmp4_;
#line 303 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 303 "../src/baobab-window.vala"
	g_return_if_fail (chart != NULL);
#line 303 "../src/baobab-window.vala"
	g_return_if_fail (iter != NULL);
#line 304 "../src/baobab-window.vala"
	_tmp0_ = self->priv->active_location;
#line 304 "../src/baobab-window.vala"
	_tmp1_ = baobab_location_get_scanner (_tmp0_);
#line 304 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 304 "../src/baobab-window.vala"
	_tmp3_ = *iter;
#line 304 "../src/baobab-window.vala"
	_tmp4_ = gtk_tree_model_get_path ((GtkTreeModel*) _tmp2_, &_tmp3_);
#line 304 "../src/baobab-window.vala"
	path = _tmp4_;
#line 305 "../src/baobab-window.vala"
	baobab_window_reroot_treeview (self, path, FALSE);
#line 303 "../src/baobab-window.vala"
	__vala_GtkTreePath_free0 (path);
#line 1606 "baobab-window.c"
}

static void
baobab_window_on_pathbar_item_activated (BaobabWindow* self,
                                         BaobabPathbar* pathbar,
                                         GtkTreePath* path)
{
#line 308 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 308 "../src/baobab-window.vala"
	g_return_if_fail (pathbar != NULL);
#line 308 "../src/baobab-window.vala"
	g_return_if_fail (path != NULL);
#line 309 "../src/baobab-window.vala"
	baobab_window_reroot_treeview (self, path, FALSE);
#line 1622 "baobab-window.c"
}

static void
baobab_window_on_folder_display_activated (BaobabWindow* self)
{
#line 312 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 313 "../src/baobab-window.vala"
	baobab_window_go_up_treeview (self);
#line 1632 "baobab-window.c"
}

static GtkTreePath*
_vala_GtkTreePath_copy (GtkTreePath* self)
{
#line 317 "../src/baobab-window.vala"
	return g_boxed_copy (gtk_tree_path_get_type (), self);
#line 1640 "baobab-window.c"
}

static gpointer
__vala_GtkTreePath_copy0 (gpointer self)
{
#line 317 "../src/baobab-window.vala"
	return self ? _vala_GtkTreePath_copy (self) : NULL;
#line 1648 "baobab-window.c"
}

static void
baobab_window_go_up_treeview (BaobabWindow* self)
{
	GtkTreePath* path = NULL;
	BaobabFolderDisplay* _tmp0_;
	GtkTreePath* _tmp1_;
	GtkTreePath* _tmp2_;
	GtkTreePath* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GtkTreePath* _tmp5_;
#line 316 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 317 "../src/baobab-window.vala"
	_tmp0_ = self->priv->folder_display;
#line 317 "../src/baobab-window.vala"
	_tmp1_ = baobab_folder_display_get_path (_tmp0_);
#line 317 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 317 "../src/baobab-window.vala"
	_tmp3_ = __vala_GtkTreePath_copy0 (_tmp2_);
#line 317 "../src/baobab-window.vala"
	path = _tmp3_;
#line 318 "../src/baobab-window.vala"
	_tmp5_ = path;
#line 318 "../src/baobab-window.vala"
	if (_tmp5_ != NULL) {
#line 1677 "baobab-window.c"
		GtkTreePath* _tmp6_;
#line 318 "../src/baobab-window.vala"
		_tmp6_ = path;
#line 318 "../src/baobab-window.vala"
		_tmp4_ = gtk_tree_path_get_depth (_tmp6_) > 1;
#line 1683 "baobab-window.c"
	} else {
#line 318 "../src/baobab-window.vala"
		_tmp4_ = FALSE;
#line 1687 "baobab-window.c"
	}
#line 318 "../src/baobab-window.vala"
	if (_tmp4_) {
#line 1691 "baobab-window.c"
		GtkTreePath* cursor_path = NULL;
		GtkTreePath* _tmp7_;
		GtkTreePath* _tmp8_;
		GtkTreePath* _tmp9_;
		GtkTreePath* _tmp10_;
		GtkTreePath* _tmp11_;
		GtkTreePath* _tmp12_;
		GtkTreeView* _tmp13_;
		GtkTreePath* _tmp14_;
#line 319 "../src/baobab-window.vala"
		_tmp7_ = path;
#line 319 "../src/baobab-window.vala"
		_tmp8_ = gtk_tree_path_copy (_tmp7_);
#line 319 "../src/baobab-window.vala"
		cursor_path = _tmp8_;
#line 320 "../src/baobab-window.vala"
		_tmp9_ = path;
#line 320 "../src/baobab-window.vala"
		gtk_tree_path_up (_tmp9_);
#line 321 "../src/baobab-window.vala"
		_tmp10_ = path;
#line 321 "../src/baobab-window.vala"
		baobab_window_reroot_treeview (self, _tmp10_, FALSE);
#line 322 "../src/baobab-window.vala"
		_tmp11_ = cursor_path;
#line 322 "../src/baobab-window.vala"
		_tmp12_ = baobab_window_convert_child_path_to_path (self, _tmp11_);
#line 322 "../src/baobab-window.vala"
		__vala_GtkTreePath_free0 (cursor_path);
#line 322 "../src/baobab-window.vala"
		cursor_path = _tmp12_;
#line 323 "../src/baobab-window.vala"
		_tmp13_ = self->priv->treeview;
#line 323 "../src/baobab-window.vala"
		_tmp14_ = cursor_path;
#line 323 "../src/baobab-window.vala"
		gtk_tree_view_set_cursor (_tmp13_, _tmp14_, NULL, FALSE);
#line 318 "../src/baobab-window.vala"
		__vala_GtkTreePath_free0 (cursor_path);
#line 1731 "baobab-window.c"
	}
#line 316 "../src/baobab-window.vala"
	__vala_GtkTreePath_free0 (path);
#line 1735 "baobab-window.c"
}

static gboolean
baobab_window_on_drop_target_accept (BaobabWindow* self,
                                     GtkDropTarget* target,
                                     GdkDrop* drop)
{
	gboolean result;
#line 327 "../src/baobab-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 327 "../src/baobab-window.vala"
	g_return_val_if_fail (target != NULL, FALSE);
#line 327 "../src/baobab-window.vala"
	g_return_val_if_fail (drop != NULL, FALSE);
#line 328 "../src/baobab-window.vala"
	result = !self->priv->is_busy;
#line 328 "../src/baobab-window.vala"
	return result;
#line 1754 "baobab-window.c"
}

static gboolean
baobab_window_on_drop (BaobabWindow* self,
                       GtkDropTarget* target,
                       GValue* value,
                       gdouble x,
                       gdouble y)
{
	gboolean result;
#line 331 "../src/baobab-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 331 "../src/baobab-window.vala"
	g_return_val_if_fail (target != NULL, FALSE);
#line 331 "../src/baobab-window.vala"
	g_return_val_if_fail (value != NULL, FALSE);
#line 332 "../src/baobab-window.vala"
	if (G_VALUE_TYPE (value) == gdk_file_list_get_type ()) {
#line 1773 "baobab-window.c"
		GSList* files = NULL;
		void* _tmp0_;
		GFile* dir = NULL;
		gboolean _tmp1_ = FALSE;
		GSList* _tmp2_;
		GFile* _tmp8_;
#line 333 "../src/baobab-window.vala"
		_tmp0_ = g_value_get_boxed (value);
#line 333 "../src/baobab-window.vala"
		files = (GSList*) _tmp0_;
#line 334 "../src/baobab-window.vala"
		dir = NULL;
#line 335 "../src/baobab-window.vala"
		_tmp2_ = files;
#line 335 "../src/baobab-window.vala"
		if (_tmp2_ != NULL) {
#line 1790 "baobab-window.c"
			GSList* _tmp3_;
#line 335 "../src/baobab-window.vala"
			_tmp3_ = files;
#line 335 "../src/baobab-window.vala"
			_tmp1_ = g_slist_length (_tmp3_) == ((guint) 1);
#line 1796 "baobab-window.c"
		} else {
#line 335 "../src/baobab-window.vala"
			_tmp1_ = FALSE;
#line 1800 "baobab-window.c"
		}
#line 335 "../src/baobab-window.vala"
		if (_tmp1_) {
#line 1804 "baobab-window.c"
			GSList* _tmp4_;
			GSList* _tmp5_;
			gconstpointer _tmp6_;
			GFile* _tmp7_;
#line 336 "../src/baobab-window.vala"
			_tmp4_ = files;
#line 336 "../src/baobab-window.vala"
			_tmp5_ = g_slist_nth (_tmp4_, (guint) 0);
#line 336 "../src/baobab-window.vala"
			_tmp6_ = _tmp5_->data;
#line 336 "../src/baobab-window.vala"
			_tmp7_ = _g_object_ref0 ((GFile*) _tmp6_);
#line 336 "../src/baobab-window.vala"
			_g_object_unref0 (dir);
#line 336 "../src/baobab-window.vala"
			dir = _tmp7_;
#line 1821 "baobab-window.c"
		}
#line 339 "../src/baobab-window.vala"
		_tmp8_ = dir;
#line 339 "../src/baobab-window.vala"
		if (_tmp8_ != NULL) {
#line 1827 "baobab-window.c"
			GFile* _tmp9_;
#line 340 "../src/baobab-window.vala"
			_tmp9_ = dir;
#line 340 "../src/baobab-window.vala"
			baobab_window_scan_directory (self, _tmp9_, BAOBAB_SCAN_FLAGS_NONE);
#line 1833 "baobab-window.c"
		}
#line 343 "../src/baobab-window.vala"
		result = TRUE;
#line 343 "../src/baobab-window.vala"
		_g_object_unref0 (dir);
#line 343 "../src/baobab-window.vala"
		return result;
#line 1841 "baobab-window.c"
	}
#line 346 "../src/baobab-window.vala"
	result = FALSE;
#line 346 "../src/baobab-window.vala"
	return result;
#line 1847 "baobab-window.c"
}

static gboolean
baobab_window_show_treeview_popover (BaobabWindow* self,
                                     GtkPopoverMenu* popover,
                                     gint x,
                                     gint y)
{
	GdkRectangle rect = {0};
	GdkRectangle _tmp0_ = {0};
	GdkRectangle _tmp1_;
	gboolean result;
#line 349 "../src/baobab-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 349 "../src/baobab-window.vala"
	g_return_val_if_fail (popover != NULL, FALSE);
#line 350 "../src/baobab-window.vala"
	_tmp0_.x = x;
#line 350 "../src/baobab-window.vala"
	_tmp0_.y = y;
#line 350 "../src/baobab-window.vala"
	_tmp0_.width = 0;
#line 350 "../src/baobab-window.vala"
	_tmp0_.height = 0;
#line 350 "../src/baobab-window.vala"
	rect = _tmp0_;
#line 351 "../src/baobab-window.vala"
	_tmp1_ = rect;
#line 351 "../src/baobab-window.vala"
	gtk_popover_set_pointing_to ((GtkPopover*) popover, &_tmp1_);
#line 352 "../src/baobab-window.vala"
	gtk_popover_popup ((GtkPopover*) popover);
#line 353 "../src/baobab-window.vala"
	result = GDK_EVENT_STOP;
#line 353 "../src/baobab-window.vala"
	return result;
#line 1884 "baobab-window.c"
}

void
baobab_window_open_item (BaobabWindow* self,
                         GtkTreeIter* iter)
{
	GFile* file = NULL;
	BaobabLocation* _tmp0_;
	BaobabScanner* _tmp1_;
	BaobabScanner* _tmp2_;
	GtkTreeIter _tmp3_;
	GFile* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 356 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 356 "../src/baobab-window.vala"
	g_return_if_fail (iter != NULL);
#line 357 "../src/baobab-window.vala"
	_tmp0_ = self->priv->active_location;
#line 357 "../src/baobab-window.vala"
	_tmp1_ = baobab_location_get_scanner (_tmp0_);
#line 357 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 357 "../src/baobab-window.vala"
	_tmp3_ = *iter;
#line 357 "../src/baobab-window.vala"
	_tmp4_ = baobab_scanner_get_file (_tmp2_, &_tmp3_);
#line 357 "../src/baobab-window.vala"
	file = _tmp4_;
#line 1914 "baobab-window.c"
	{
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 359 "../src/baobab-window.vala"
		_tmp5_ = g_file_get_uri (file);
#line 359 "../src/baobab-window.vala"
		_tmp6_ = _tmp5_;
#line 359 "../src/baobab-window.vala"
		g_app_info_launch_default_for_uri (_tmp6_, NULL, &_inner_error0_);
#line 359 "../src/baobab-window.vala"
		_g_free0 (_tmp6_);
#line 359 "../src/baobab-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1928 "baobab-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 358 "../src/baobab-window.vala"
		e = _inner_error0_;
#line 358 "../src/baobab-window.vala"
		_inner_error0_ = NULL;
#line 361 "../src/baobab-window.vala"
		_tmp7_ = e;
#line 361 "../src/baobab-window.vala"
		_tmp8_ = _tmp7_->message;
#line 361 "../src/baobab-window.vala"
		baobab_window_message (self, _ ("Failed to open file"), _tmp8_, GTK_MESSAGE_ERROR);
#line 358 "../src/baobab-window.vala"
		_g_error_free0 (e);
#line 1950 "baobab-window.c"
	}
	__finally0:
#line 358 "../src/baobab-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 358 "../src/baobab-window.vala"
		_g_object_unref0 (file);
#line 358 "../src/baobab-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 358 "../src/baobab-window.vala"
		g_clear_error (&_inner_error0_);
#line 358 "../src/baobab-window.vala"
		return;
#line 1963 "baobab-window.c"
	}
#line 356 "../src/baobab-window.vala"
	_g_object_unref0 (file);
#line 1967 "baobab-window.c"
}

void
baobab_window_copy_path (BaobabWindow* self,
                         GtkTreeIter* iter)
{
	gchar* parse_name = NULL;
	BaobabLocation* _tmp0_;
	BaobabScanner* _tmp1_;
	BaobabScanner* _tmp2_;
	GtkTreeIter _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GdkClipboard* clipboard = NULL;
	GdkClipboard* _tmp8_;
	GdkClipboard* _tmp9_;
#line 365 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 365 "../src/baobab-window.vala"
	g_return_if_fail (iter != NULL);
#line 366 "../src/baobab-window.vala"
	_tmp0_ = self->priv->active_location;
#line 366 "../src/baobab-window.vala"
	_tmp1_ = baobab_location_get_scanner (_tmp0_);
#line 366 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 366 "../src/baobab-window.vala"
	_tmp3_ = *iter;
#line 366 "../src/baobab-window.vala"
	_tmp4_ = baobab_scanner_get_file (_tmp2_, &_tmp3_);
#line 366 "../src/baobab-window.vala"
	_tmp5_ = _tmp4_;
#line 366 "../src/baobab-window.vala"
	_tmp6_ = g_file_get_parse_name (_tmp5_);
#line 366 "../src/baobab-window.vala"
	_tmp7_ = _tmp6_;
#line 366 "../src/baobab-window.vala"
	_g_object_unref0 (_tmp5_);
#line 366 "../src/baobab-window.vala"
	parse_name = _tmp7_;
#line 367 "../src/baobab-window.vala"
	_tmp8_ = gtk_widget_get_clipboard ((GtkWidget*) self);
#line 367 "../src/baobab-window.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 367 "../src/baobab-window.vala"
	clipboard = _tmp9_;
#line 368 "../src/baobab-window.vala"
	gdk_clipboard_set_text (clipboard, parse_name);
#line 365 "../src/baobab-window.vala"
	_g_object_unref0 (clipboard);
#line 365 "../src/baobab-window.vala"
	_g_free0 (parse_name);
#line 2022 "baobab-window.c"
}

void
baobab_window_trash_file (BaobabWindow* self,
                          GtkTreeIter* iter)
{
	GFile* file = NULL;
	BaobabLocation* _tmp0_;
	BaobabScanner* _tmp1_;
	BaobabScanner* _tmp2_;
	GtkTreeIter _tmp3_;
	GFile* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 371 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 371 "../src/baobab-window.vala"
	g_return_if_fail (iter != NULL);
#line 372 "../src/baobab-window.vala"
	_tmp0_ = self->priv->active_location;
#line 372 "../src/baobab-window.vala"
	_tmp1_ = baobab_location_get_scanner (_tmp0_);
#line 372 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 372 "../src/baobab-window.vala"
	_tmp3_ = *iter;
#line 372 "../src/baobab-window.vala"
	_tmp4_ = baobab_scanner_get_file (_tmp2_, &_tmp3_);
#line 372 "../src/baobab-window.vala"
	file = _tmp4_;
#line 2052 "baobab-window.c"
	{
		BaobabLocation* _tmp5_;
		BaobabScanner* _tmp6_;
		BaobabScanner* _tmp7_;
#line 374 "../src/baobab-window.vala"
		g_file_trash (file, NULL, &_inner_error0_);
#line 374 "../src/baobab-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2061 "baobab-window.c"
			goto __catch0_g_error;
		}
#line 375 "../src/baobab-window.vala"
		_tmp5_ = self->priv->active_location;
#line 375 "../src/baobab-window.vala"
		_tmp6_ = baobab_location_get_scanner (_tmp5_);
#line 375 "../src/baobab-window.vala"
		_tmp7_ = _tmp6_;
#line 375 "../src/baobab-window.vala"
		gtk_tree_store_remove ((GtkTreeStore*) _tmp7_, iter);
#line 2072 "baobab-window.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 373 "../src/baobab-window.vala"
		e = _inner_error0_;
#line 373 "../src/baobab-window.vala"
		_inner_error0_ = NULL;
#line 377 "../src/baobab-window.vala"
		_tmp8_ = e;
#line 377 "../src/baobab-window.vala"
		_tmp9_ = _tmp8_->message;
#line 377 "../src/baobab-window.vala"
		baobab_window_message (self, _ ("Failed to move file to the trash"), _tmp9_, GTK_MESSAGE_ERROR);
#line 373 "../src/baobab-window.vala"
		_g_error_free0 (e);
#line 2092 "baobab-window.c"
	}
	__finally0:
#line 373 "../src/baobab-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 373 "../src/baobab-window.vala"
		_g_object_unref0 (file);
#line 373 "../src/baobab-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 373 "../src/baobab-window.vala"
		g_clear_error (&_inner_error0_);
#line 373 "../src/baobab-window.vala"
		return;
#line 2105 "baobab-window.c"
	}
#line 371 "../src/baobab-window.vala"
	_g_object_unref0 (file);
#line 2109 "baobab-window.c"
}

static gboolean
baobab_window_get_selected_iter (BaobabWindow* self,
                                 GtkTreeIter* iter)
{
	GtkTreeIter _vala_iter = {0};
	GtkTreeIter wrapper_iter = {0};
	GtkTreeSelection* selection = NULL;
	GtkTreeView* _tmp0_;
	GtkTreeSelection* _tmp1_;
	GtkTreeSelection* _tmp2_;
	gboolean _result_ = FALSE;
	GtkTreeIter _tmp3_ = {0};
	gboolean _tmp4_;
	GtkTreeIter _tmp5_;
	GtkTreeIter _tmp6_ = {0};
	gboolean result;
#line 381 "../src/baobab-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 384 "../src/baobab-window.vala"
	_tmp0_ = self->priv->treeview;
#line 384 "../src/baobab-window.vala"
	_tmp1_ = gtk_tree_view_get_selection (_tmp0_);
#line 384 "../src/baobab-window.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 384 "../src/baobab-window.vala"
	selection = _tmp2_;
#line 385 "../src/baobab-window.vala"
	_tmp4_ = gtk_tree_selection_get_selected (selection, NULL, &_tmp3_);
#line 385 "../src/baobab-window.vala"
	wrapper_iter = _tmp3_;
#line 385 "../src/baobab-window.vala"
	_result_ = _tmp4_;
#line 387 "../src/baobab-window.vala"
	_tmp5_ = wrapper_iter;
#line 387 "../src/baobab-window.vala"
	baobab_window_convert_iter_to_child_iter (self, &_tmp6_, &_tmp5_);
#line 387 "../src/baobab-window.vala"
	_vala_iter = _tmp6_;
#line 389 "../src/baobab-window.vala"
	result = _result_;
#line 389 "../src/baobab-window.vala"
	_g_object_unref0 (selection);
#line 389 "../src/baobab-window.vala"
	if (iter) {
#line 389 "../src/baobab-window.vala"
		*iter = _vala_iter;
#line 2158 "baobab-window.c"
	}
#line 389 "../src/baobab-window.vala"
	return result;
#line 2162 "baobab-window.c"
}

static void
baobab_window_convert_iter_to_child_iter (BaobabWindow* self,
                                          GtkTreeIter* child_iter,
                                          GtkTreeIter* iter)
{
	GtkTreeIter _vala_child_iter = {0};
	GtkTreeIter filter_iter = {0};
	GtkTreeModelSort* sort = NULL;
	GtkTreeView* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreeModel* _tmp2_;
	GtkTreeModelSort* _tmp3_;
	GtkTreeIter _tmp4_;
	GtkTreeIter _tmp5_ = {0};
	GtkTreeModelFilter* filter = NULL;
	GtkTreeModel* _tmp6_;
	GtkTreeModel* _tmp7_;
	GtkTreeModelFilter* _tmp8_;
	GtkTreeIter _tmp9_;
	GtkTreeIter _tmp10_ = {0};
#line 392 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 392 "../src/baobab-window.vala"
	g_return_if_fail (iter != NULL);
#line 395 "../src/baobab-window.vala"
	_tmp0_ = self->priv->treeview;
#line 395 "../src/baobab-window.vala"
	_tmp1_ = gtk_tree_view_get_model (_tmp0_);
#line 395 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 395 "../src/baobab-window.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_tree_model_sort_get_type (), GtkTreeModelSort));
#line 395 "../src/baobab-window.vala"
	sort = _tmp3_;
#line 396 "../src/baobab-window.vala"
	_tmp4_ = *iter;
#line 396 "../src/baobab-window.vala"
	gtk_tree_model_sort_convert_iter_to_child_iter (sort, &_tmp5_, &_tmp4_);
#line 396 "../src/baobab-window.vala"
	filter_iter = _tmp5_;
#line 398 "../src/baobab-window.vala"
	_tmp6_ = gtk_tree_model_sort_get_model (sort);
#line 398 "../src/baobab-window.vala"
	_tmp7_ = _tmp6_;
#line 398 "../src/baobab-window.vala"
	_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_tree_model_filter_get_type (), GtkTreeModelFilter));
#line 398 "../src/baobab-window.vala"
	filter = _tmp8_;
#line 399 "../src/baobab-window.vala"
	_tmp9_ = filter_iter;
#line 399 "../src/baobab-window.vala"
	gtk_tree_model_filter_convert_iter_to_child_iter (filter, &_tmp10_, &_tmp9_);
#line 399 "../src/baobab-window.vala"
	_vala_child_iter = _tmp10_;
#line 392 "../src/baobab-window.vala"
	_g_object_unref0 (filter);
#line 392 "../src/baobab-window.vala"
	_g_object_unref0 (sort);
#line 392 "../src/baobab-window.vala"
	if (child_iter) {
#line 392 "../src/baobab-window.vala"
		*child_iter = _vala_child_iter;
#line 2227 "baobab-window.c"
	}
}

static GtkTreePath*
baobab_window_convert_path_to_child_path (BaobabWindow* self,
                                          GtkTreePath* path)
{
	GtkTreeModelSort* sort = NULL;
	GtkTreeView* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreeModel* _tmp2_;
	GtkTreeModelSort* _tmp3_;
	GtkTreePath* filter_path = NULL;
	GtkTreePath* _tmp4_;
	GtkTreeModelFilter* filter = NULL;
	GtkTreeModel* _tmp5_;
	GtkTreeModel* _tmp6_;
	GtkTreeModelFilter* _tmp7_;
	GtkTreePath* _tmp8_;
	GtkTreePath* result;
#line 402 "../src/baobab-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 402 "../src/baobab-window.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 403 "../src/baobab-window.vala"
	_tmp0_ = self->priv->treeview;
#line 403 "../src/baobab-window.vala"
	_tmp1_ = gtk_tree_view_get_model (_tmp0_);
#line 403 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 403 "../src/baobab-window.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_tree_model_sort_get_type (), GtkTreeModelSort));
#line 403 "../src/baobab-window.vala"
	sort = _tmp3_;
#line 404 "../src/baobab-window.vala"
	_tmp4_ = gtk_tree_model_sort_convert_path_to_child_path (sort, path);
#line 404 "../src/baobab-window.vala"
	filter_path = _tmp4_;
#line 406 "../src/baobab-window.vala"
	_tmp5_ = gtk_tree_model_sort_get_model (sort);
#line 406 "../src/baobab-window.vala"
	_tmp6_ = _tmp5_;
#line 406 "../src/baobab-window.vala"
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_tree_model_filter_get_type (), GtkTreeModelFilter));
#line 406 "../src/baobab-window.vala"
	filter = _tmp7_;
#line 407 "../src/baobab-window.vala"
	_tmp8_ = gtk_tree_model_filter_convert_path_to_child_path (filter, filter_path);
#line 407 "../src/baobab-window.vala"
	result = _tmp8_;
#line 407 "../src/baobab-window.vala"
	_g_object_unref0 (filter);
#line 407 "../src/baobab-window.vala"
	__vala_GtkTreePath_free0 (filter_path);
#line 407 "../src/baobab-window.vala"
	_g_object_unref0 (sort);
#line 407 "../src/baobab-window.vala"
	return result;
#line 2286 "baobab-window.c"
}

static GtkTreePath*
baobab_window_convert_child_path_to_path (BaobabWindow* self,
                                          GtkTreePath* path)
{
	GtkTreeModelSort* sort = NULL;
	GtkTreeView* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreeModel* _tmp2_;
	GtkTreeModelSort* _tmp3_;
	GtkTreeModelFilter* filter = NULL;
	GtkTreeModel* _tmp4_;
	GtkTreeModel* _tmp5_;
	GtkTreeModelFilter* _tmp6_;
	GtkTreePath* filter_path = NULL;
	GtkTreePath* _tmp7_;
	GtkTreePath* _tmp8_;
	GtkTreePath* result;
#line 410 "../src/baobab-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 410 "../src/baobab-window.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 411 "../src/baobab-window.vala"
	_tmp0_ = self->priv->treeview;
#line 411 "../src/baobab-window.vala"
	_tmp1_ = gtk_tree_view_get_model (_tmp0_);
#line 411 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 411 "../src/baobab-window.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_tree_model_sort_get_type (), GtkTreeModelSort));
#line 411 "../src/baobab-window.vala"
	sort = _tmp3_;
#line 412 "../src/baobab-window.vala"
	_tmp4_ = gtk_tree_model_sort_get_model (sort);
#line 412 "../src/baobab-window.vala"
	_tmp5_ = _tmp4_;
#line 412 "../src/baobab-window.vala"
	_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_tree_model_filter_get_type (), GtkTreeModelFilter));
#line 412 "../src/baobab-window.vala"
	filter = _tmp6_;
#line 413 "../src/baobab-window.vala"
	_tmp7_ = gtk_tree_model_filter_convert_child_path_to_path (filter, path);
#line 413 "../src/baobab-window.vala"
	filter_path = _tmp7_;
#line 414 "../src/baobab-window.vala"
	_tmp8_ = gtk_tree_model_sort_convert_child_path_to_path (sort, filter_path);
#line 414 "../src/baobab-window.vala"
	result = _tmp8_;
#line 414 "../src/baobab-window.vala"
	__vala_GtkTreePath_free0 (filter_path);
#line 414 "../src/baobab-window.vala"
	_g_object_unref0 (filter);
#line 414 "../src/baobab-window.vala"
	_g_object_unref0 (sort);
#line 414 "../src/baobab-window.vala"
	return result;
#line 2344 "baobab-window.c"
}

static void
baobab_window_on_show_treeview_popover (BaobabWindow* self)
{
	GtkPopoverMenu* _tmp0_;
	GtkTreeView* _tmp1_;
	GtkTreeView* _tmp2_;
#line 417 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 418 "../src/baobab-window.vala"
	_tmp0_ = self->priv->treeview_popover_menu;
#line 418 "../src/baobab-window.vala"
	_tmp1_ = self->priv->treeview;
#line 418 "../src/baobab-window.vala"
	_tmp2_ = self->priv->treeview;
#line 418 "../src/baobab-window.vala"
	baobab_window_show_treeview_popover (self, _tmp0_, gtk_widget_get_allocated_width ((GtkWidget*) _tmp1_) / 2, gtk_widget_get_allocated_height ((GtkWidget*) _tmp2_) / 2);
#line 2363 "baobab-window.c"
}

static void
baobab_window_on_treeview_expand_row (BaobabWindow* self)
{
	GtkTreeIter iter = {0};
	GtkTreeView* _tmp0_;
	GtkTreeSelection* _tmp1_;
	GtkTreeIter _tmp2_ = {0};
	gboolean _tmp3_;
#line 423 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 425 "../src/baobab-window.vala"
	_tmp0_ = self->priv->treeview;
#line 425 "../src/baobab-window.vala"
	_tmp1_ = gtk_tree_view_get_selection (_tmp0_);
#line 425 "../src/baobab-window.vala"
	_tmp3_ = gtk_tree_selection_get_selected (_tmp1_, NULL, &_tmp2_);
#line 425 "../src/baobab-window.vala"
	iter = _tmp2_;
#line 425 "../src/baobab-window.vala"
	if (_tmp3_) {
#line 2386 "baobab-window.c"
		GtkTreePath* path = NULL;
		GtkTreeView* _tmp4_;
		GtkTreeModel* _tmp5_;
		GtkTreeModel* _tmp6_;
		GtkTreeIter _tmp7_;
		GtkTreePath* _tmp8_;
		GtkTreeView* _tmp9_;
		GtkTreePath* _tmp10_;
#line 426 "../src/baobab-window.vala"
		_tmp4_ = self->priv->treeview;
#line 426 "../src/baobab-window.vala"
		_tmp5_ = gtk_tree_view_get_model (_tmp4_);
#line 426 "../src/baobab-window.vala"
		_tmp6_ = _tmp5_;
#line 426 "../src/baobab-window.vala"
		_tmp7_ = iter;
#line 426 "../src/baobab-window.vala"
		_tmp8_ = gtk_tree_model_get_path (_tmp6_, &_tmp7_);
#line 426 "../src/baobab-window.vala"
		path = _tmp8_;
#line 427 "../src/baobab-window.vala"
		_tmp9_ = self->priv->treeview;
#line 427 "../src/baobab-window.vala"
		_tmp10_ = path;
#line 427 "../src/baobab-window.vala"
		gtk_tree_view_expand_row (_tmp9_, _tmp10_, FALSE);
#line 425 "../src/baobab-window.vala"
		__vala_GtkTreePath_free0 (path);
#line 2415 "baobab-window.c"
	}
}

static void
baobab_window_on_treeview_collapse_row (BaobabWindow* self)
{
	GtkTreeIter iter = {0};
	GtkTreeView* _tmp0_;
	GtkTreeSelection* _tmp1_;
	GtkTreeIter _tmp2_ = {0};
	gboolean _tmp3_;
#line 431 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 433 "../src/baobab-window.vala"
	_tmp0_ = self->priv->treeview;
#line 433 "../src/baobab-window.vala"
	_tmp1_ = gtk_tree_view_get_selection (_tmp0_);
#line 433 "../src/baobab-window.vala"
	_tmp3_ = gtk_tree_selection_get_selected (_tmp1_, NULL, &_tmp2_);
#line 433 "../src/baobab-window.vala"
	iter = _tmp2_;
#line 433 "../src/baobab-window.vala"
	if (_tmp3_) {
#line 2439 "baobab-window.c"
		GtkTreePath* path = NULL;
		GtkTreeView* _tmp4_;
		GtkTreeModel* _tmp5_;
		GtkTreeModel* _tmp6_;
		GtkTreeIter _tmp7_;
		GtkTreePath* _tmp8_;
		gboolean _tmp9_ = FALSE;
		GtkTreeView* _tmp10_;
		GtkTreePath* _tmp11_;
#line 434 "../src/baobab-window.vala"
		_tmp4_ = self->priv->treeview;
#line 434 "../src/baobab-window.vala"
		_tmp5_ = gtk_tree_view_get_model (_tmp4_);
#line 434 "../src/baobab-window.vala"
		_tmp6_ = _tmp5_;
#line 434 "../src/baobab-window.vala"
		_tmp7_ = iter;
#line 434 "../src/baobab-window.vala"
		_tmp8_ = gtk_tree_model_get_path (_tmp6_, &_tmp7_);
#line 434 "../src/baobab-window.vala"
		path = _tmp8_;
#line 435 "../src/baobab-window.vala"
		_tmp10_ = self->priv->treeview;
#line 435 "../src/baobab-window.vala"
		_tmp11_ = path;
#line 435 "../src/baobab-window.vala"
		if (!gtk_tree_view_collapse_row (_tmp10_, _tmp11_)) {
#line 2467 "baobab-window.c"
			GtkTreePath* _tmp12_;
#line 435 "../src/baobab-window.vala"
			_tmp12_ = path;
#line 435 "../src/baobab-window.vala"
			_tmp9_ = gtk_tree_path_up (_tmp12_);
#line 2473 "baobab-window.c"
		} else {
#line 435 "../src/baobab-window.vala"
			_tmp9_ = FALSE;
#line 2477 "baobab-window.c"
		}
#line 435 "../src/baobab-window.vala"
		if (_tmp9_) {
#line 2481 "baobab-window.c"
			GtkTreeView* _tmp13_;
			GtkTreePath* _tmp14_;
#line 436 "../src/baobab-window.vala"
			_tmp13_ = self->priv->treeview;
#line 436 "../src/baobab-window.vala"
			_tmp14_ = path;
#line 436 "../src/baobab-window.vala"
			gtk_tree_view_set_cursor (_tmp13_, _tmp14_, NULL, FALSE);
#line 2490 "baobab-window.c"
		}
#line 433 "../src/baobab-window.vala"
		__vala_GtkTreePath_free0 (path);
#line 2494 "baobab-window.c"
	}
}

static void
baobab_window_on_treeview_open_folder (BaobabWindow* self)
{
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_;
#line 441 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 443 "../src/baobab-window.vala"
	_tmp1_ = baobab_window_get_selected_iter (self, &_tmp0_);
#line 443 "../src/baobab-window.vala"
	iter = _tmp0_;
#line 443 "../src/baobab-window.vala"
	if (_tmp1_) {
#line 2512 "baobab-window.c"
		GtkTreeIter _tmp2_;
#line 444 "../src/baobab-window.vala"
		_tmp2_ = iter;
#line 444 "../src/baobab-window.vala"
		baobab_window_open_item (self, &_tmp2_);
#line 2518 "baobab-window.c"
	}
}

static void
baobab_window_on_treeview_copy (BaobabWindow* self)
{
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_;
#line 448 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 450 "../src/baobab-window.vala"
	_tmp1_ = baobab_window_get_selected_iter (self, &_tmp0_);
#line 450 "../src/baobab-window.vala"
	iter = _tmp0_;
#line 450 "../src/baobab-window.vala"
	if (_tmp1_) {
#line 2536 "baobab-window.c"
		GtkTreeIter _tmp2_;
#line 451 "../src/baobab-window.vala"
		_tmp2_ = iter;
#line 451 "../src/baobab-window.vala"
		baobab_window_copy_path (self, &_tmp2_);
#line 2542 "baobab-window.c"
	}
}

static void
baobab_window_on_treeview_trash (BaobabWindow* self)
{
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_;
#line 455 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 457 "../src/baobab-window.vala"
	_tmp1_ = baobab_window_get_selected_iter (self, &_tmp0_);
#line 457 "../src/baobab-window.vala"
	iter = _tmp0_;
#line 457 "../src/baobab-window.vala"
	if (_tmp1_) {
#line 2560 "baobab-window.c"
		GtkTreeIter _tmp2_;
#line 458 "../src/baobab-window.vala"
		_tmp2_ = iter;
#line 458 "../src/baobab-window.vala"
		baobab_window_trash_file (self, &_tmp2_);
#line 2566 "baobab-window.c"
	}
}

static void
__lambda23_ (BaobabWindow* self,
             gint n_press,
             gdouble x,
             gdouble y)
{
	GtkTreePath* path = NULL;
	GtkTreeView* _tmp0_;
	GtkTreePath* _tmp1_ = NULL;
	gboolean _tmp2_;
#line 465 "../src/baobab-window.vala"
	_tmp0_ = self->priv->treeview;
#line 465 "../src/baobab-window.vala"
	_tmp2_ = gtk_tree_view_get_path_at_pos (_tmp0_, (gint) x, (gint) y, &_tmp1_, NULL, NULL, NULL);
#line 465 "../src/baobab-window.vala"
	__vala_GtkTreePath_free0 (path);
#line 465 "../src/baobab-window.vala"
	path = _tmp1_;
#line 465 "../src/baobab-window.vala"
	if (_tmp2_) {
#line 2590 "baobab-window.c"
		GtkTreeView* _tmp3_;
		GtkTreeSelection* _tmp4_;
		GtkTreePath* _tmp5_;
		GtkPopoverMenu* _tmp6_;
#line 466 "../src/baobab-window.vala"
		_tmp3_ = self->priv->treeview;
#line 466 "../src/baobab-window.vala"
		_tmp4_ = gtk_tree_view_get_selection (_tmp3_);
#line 466 "../src/baobab-window.vala"
		_tmp5_ = path;
#line 466 "../src/baobab-window.vala"
		gtk_tree_selection_select_path (_tmp4_, _tmp5_);
#line 467 "../src/baobab-window.vala"
		_tmp6_ = self->priv->treeview_popover_menu;
#line 467 "../src/baobab-window.vala"
		baobab_window_show_treeview_popover (self, _tmp6_, (gint) x, (gint) y);
#line 2607 "baobab-window.c"
	}
#line 463 "../src/baobab-window.vala"
	__vala_GtkTreePath_free0 (path);
#line 2611 "baobab-window.c"
}

static void
___lambda23__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                        gint n_press,
                                        gdouble x,
                                        gdouble y,
                                        gpointer self)
{
#line 463 "../src/baobab-window.vala"
	__lambda23_ ((BaobabWindow*) self, n_press, x, y);
#line 2623 "baobab-window.c"
}

static void
__lambda24_ (BaobabWindow* self,
             GtkTreePath* wrapper_path,
             GtkTreeViewColumn* column)
{
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp0_;
#line 471 "../src/baobab-window.vala"
	g_return_if_fail (wrapper_path != NULL);
#line 472 "../src/baobab-window.vala"
	_tmp0_ = baobab_window_convert_path_to_child_path (self, wrapper_path);
#line 472 "../src/baobab-window.vala"
	path = _tmp0_;
#line 473 "../src/baobab-window.vala"
	baobab_window_reroot_treeview (self, path, TRUE);
#line 471 "../src/baobab-window.vala"
	__vala_GtkTreePath_free0 (path);
#line 2643 "baobab-window.c"
}

static void
___lambda24__gtk_tree_view_row_activated (GtkTreeView* _sender,
                                          GtkTreePath* path,
                                          GtkTreeViewColumn* column,
                                          gpointer self)
{
#line 471 "../src/baobab-window.vala"
	__lambda24_ ((BaobabWindow*) self, path, column);
#line 2654 "baobab-window.c"
}

static void
_baobab_window_reset_treeview_sorting_gtk_tree_sortable_sort_column_changed (GtkTreeSortable* _sender,
                                                                             gpointer self)
{
#line 477 "../src/baobab-window.vala"
	baobab_window_reset_treeview_sorting ((BaobabWindow*) self);
#line 2663 "baobab-window.c"
}

static void
_baobab_window_copy_treeview_column_sizes_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self)
{
#line 479 "../src/baobab-window.vala"
	baobab_window_copy_treeview_column_sizes ((BaobabWindow*) self);
#line 2673 "baobab-window.c"
}

static void
baobab_window_setup_treeview (BaobabWindow* self)
{
	GtkGestureClick* _tmp0_;
	GtkTreeView* _tmp1_;
	GtkTreeSortable* folder_display_model = NULL;
	BaobabFolderDisplay* _tmp2_;
	GtkTreeModel* _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkTreeSortable* _tmp5_;
	BaobabFolderDisplay* _tmp6_;
	GtkTreeViewColumn* _tmp7_;
	BaobabFolderDisplay* _tmp8_;
	GtkTreeViewColumn* _tmp9_;
	BaobabFolderDisplay* _tmp10_;
	GtkTreeViewColumn* _tmp11_;
#line 462 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 463 "../src/baobab-window.vala"
	_tmp0_ = self->priv->treeview_right_click_gesture;
#line 463 "../src/baobab-window.vala"
	g_signal_connect_object (_tmp0_, "pressed", (GCallback) ___lambda23__gtk_gesture_click_pressed, self, 0);
#line 471 "../src/baobab-window.vala"
	_tmp1_ = self->priv->treeview;
#line 471 "../src/baobab-window.vala"
	g_signal_connect_object (_tmp1_, "row-activated", (GCallback) ___lambda24__gtk_tree_view_row_activated, self, 0);
#line 476 "../src/baobab-window.vala"
	_tmp2_ = self->priv->folder_display;
#line 476 "../src/baobab-window.vala"
	_tmp3_ = gtk_tree_view_get_model ((GtkTreeView*) _tmp2_);
#line 476 "../src/baobab-window.vala"
	_tmp4_ = _tmp3_;
#line 476 "../src/baobab-window.vala"
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_tree_sortable_get_type (), GtkTreeSortable));
#line 476 "../src/baobab-window.vala"
	folder_display_model = _tmp5_;
#line 477 "../src/baobab-window.vala"
	g_signal_connect_object (folder_display_model, "sort-column-changed", (GCallback) _baobab_window_reset_treeview_sorting_gtk_tree_sortable_sort_column_changed, self, 0);
#line 479 "../src/baobab-window.vala"
	_tmp6_ = self->priv->folder_display;
#line 479 "../src/baobab-window.vala"
	_tmp7_ = _tmp6_->size_column;
#line 479 "../src/baobab-window.vala"
	g_signal_connect_object ((GObject*) _tmp7_, "notify::width", (GCallback) _baobab_window_copy_treeview_column_sizes_g_object_notify, self, 0);
#line 480 "../src/baobab-window.vala"
	_tmp8_ = self->priv->folder_display;
#line 480 "../src/baobab-window.vala"
	_tmp9_ = _tmp8_->contents_column;
#line 480 "../src/baobab-window.vala"
	g_signal_connect_object ((GObject*) _tmp9_, "notify::width", (GCallback) _baobab_window_copy_treeview_column_sizes_g_object_notify, self, 0);
#line 481 "../src/baobab-window.vala"
	_tmp10_ = self->priv->folder_display;
#line 481 "../src/baobab-window.vala"
	_tmp11_ = _tmp10_->time_modified_column;
#line 481 "../src/baobab-window.vala"
	g_signal_connect_object ((GObject*) _tmp11_, "notify::width", (GCallback) _baobab_window_copy_treeview_column_sizes_g_object_notify, self, 0);
#line 462 "../src/baobab-window.vala"
	_g_object_unref0 (folder_display_model);
#line 2734 "baobab-window.c"
}

static void
baobab_window_copy_treeview_column_sizes (BaobabWindow* self)
{
	GtkTreeViewColumn* _tmp0_;
	BaobabFolderDisplay* _tmp1_;
	GtkTreeViewColumn* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GtkTreeViewColumn* _tmp5_;
	BaobabFolderDisplay* _tmp6_;
	GtkTreeViewColumn* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	GtkTreeViewColumn* _tmp10_;
	BaobabFolderDisplay* _tmp11_;
	GtkTreeViewColumn* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
#line 484 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 485 "../src/baobab-window.vala"
	_tmp0_ = self->priv->size_column;
#line 485 "../src/baobab-window.vala"
	_tmp1_ = self->priv->folder_display;
#line 485 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_->size_column;
#line 485 "../src/baobab-window.vala"
	_tmp3_ = gtk_tree_view_column_get_width (_tmp2_);
#line 485 "../src/baobab-window.vala"
	_tmp4_ = _tmp3_;
#line 485 "../src/baobab-window.vala"
	gtk_tree_view_column_set_min_width (_tmp0_, _tmp4_);
#line 486 "../src/baobab-window.vala"
	_tmp5_ = self->priv->contents_column;
#line 486 "../src/baobab-window.vala"
	_tmp6_ = self->priv->folder_display;
#line 486 "../src/baobab-window.vala"
	_tmp7_ = _tmp6_->contents_column;
#line 486 "../src/baobab-window.vala"
	_tmp8_ = gtk_tree_view_column_get_width (_tmp7_);
#line 486 "../src/baobab-window.vala"
	_tmp9_ = _tmp8_;
#line 486 "../src/baobab-window.vala"
	gtk_tree_view_column_set_min_width (_tmp5_, _tmp9_);
#line 487 "../src/baobab-window.vala"
	_tmp10_ = self->priv->time_modified_column;
#line 487 "../src/baobab-window.vala"
	_tmp11_ = self->priv->folder_display;
#line 487 "../src/baobab-window.vala"
	_tmp12_ = _tmp11_->time_modified_column;
#line 487 "../src/baobab-window.vala"
	_tmp13_ = gtk_tree_view_column_get_width (_tmp12_);
#line 487 "../src/baobab-window.vala"
	_tmp14_ = _tmp13_;
#line 487 "../src/baobab-window.vala"
	gtk_tree_view_column_set_min_width (_tmp10_, _tmp14_);
#line 2793 "baobab-window.c"
}

static void
baobab_window_reset_treeview_sorting (BaobabWindow* self)
{
	gint id = 0;
	GtkSortType sort_type = 0;
	GtkTreeSortable* folder_display_model = NULL;
	BaobabFolderDisplay* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreeModel* _tmp2_;
	GtkTreeSortable* _tmp3_;
	GtkTreeSortable* treeview_model = NULL;
	GtkTreeView* _tmp4_;
	GtkTreeModel* _tmp5_;
	GtkTreeModel* _tmp6_;
	GtkTreeSortable* _tmp7_;
	gint _tmp8_ = 0;
	GtkSortType _tmp9_ = 0;
#line 490 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 494 "../src/baobab-window.vala"
	_tmp0_ = self->priv->folder_display;
#line 494 "../src/baobab-window.vala"
	_tmp1_ = gtk_tree_view_get_model ((GtkTreeView*) _tmp0_);
#line 494 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 494 "../src/baobab-window.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_tree_sortable_get_type (), GtkTreeSortable));
#line 494 "../src/baobab-window.vala"
	folder_display_model = _tmp3_;
#line 495 "../src/baobab-window.vala"
	_tmp4_ = self->priv->treeview;
#line 495 "../src/baobab-window.vala"
	_tmp5_ = gtk_tree_view_get_model (_tmp4_);
#line 495 "../src/baobab-window.vala"
	_tmp6_ = _tmp5_;
#line 495 "../src/baobab-window.vala"
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_tree_sortable_get_type (), GtkTreeSortable));
#line 495 "../src/baobab-window.vala"
	treeview_model = _tmp7_;
#line 497 "../src/baobab-window.vala"
	gtk_tree_sortable_get_sort_column_id (folder_display_model, &_tmp8_, &_tmp9_);
#line 497 "../src/baobab-window.vala"
	id = _tmp8_;
#line 497 "../src/baobab-window.vala"
	sort_type = _tmp9_;
#line 498 "../src/baobab-window.vala"
	gtk_tree_sortable_set_sort_column_id (treeview_model, id, sort_type);
#line 490 "../src/baobab-window.vala"
	_g_object_unref0 (treeview_model);
#line 490 "../src/baobab-window.vala"
	_g_object_unref0 (folder_display_model);
#line 2847 "baobab-window.c"
}

static void
baobab_window_reroot_treeview (BaobabWindow* self,
                               GtkTreePath* path,
                               gboolean select_first)
{
	GtkTreeIter iter = {0};
	BaobabLocation* _tmp0_;
	BaobabScanner* _tmp1_;
	BaobabScanner* _tmp2_;
	GtkTreeIter _tmp3_ = {0};
	BaobabLocation* _tmp4_;
	BaobabScanner* _tmp5_;
	BaobabScanner* _tmp6_;
	GtkTreeIter _tmp7_;
	BaobabChart* _tmp8_;
	BaobabChart* _tmp9_;
	BaobabFolderDisplay* _tmp10_;
	BaobabPathbar* _tmp11_;
	GtkTreeModelFilter* filter = NULL;
	BaobabLocation* _tmp12_;
	BaobabScanner* _tmp13_;
	BaobabScanner* _tmp14_;
	GtkTreeModelFilter* _tmp15_;
	GtkTreeView* _tmp16_;
	GtkTreeModelFilter* _tmp17_;
	GtkTreeModelSort* _tmp18_;
	GtkTreeModelSort* _tmp19_;
#line 502 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 502 "../src/baobab-window.vala"
	g_return_if_fail (path != NULL);
#line 504 "../src/baobab-window.vala"
	_tmp0_ = self->priv->active_location;
#line 504 "../src/baobab-window.vala"
	_tmp1_ = baobab_location_get_scanner (_tmp0_);
#line 504 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 504 "../src/baobab-window.vala"
	gtk_tree_model_get_iter ((GtkTreeModel*) _tmp2_, &_tmp3_, path);
#line 504 "../src/baobab-window.vala"
	iter = _tmp3_;
#line 505 "../src/baobab-window.vala"
	_tmp4_ = self->priv->active_location;
#line 505 "../src/baobab-window.vala"
	_tmp5_ = baobab_location_get_scanner (_tmp4_);
#line 505 "../src/baobab-window.vala"
	_tmp6_ = _tmp5_;
#line 505 "../src/baobab-window.vala"
	_tmp7_ = iter;
#line 505 "../src/baobab-window.vala"
	if (!gtk_tree_model_iter_has_child ((GtkTreeModel*) _tmp6_, &_tmp7_)) {
#line 506 "../src/baobab-window.vala"
		return;
#line 2903 "baobab-window.c"
	}
#line 509 "../src/baobab-window.vala"
	_tmp8_ = self->priv->rings_chart;
#line 509 "../src/baobab-window.vala"
	baobab_chart_set_tree_root (_tmp8_, path);
#line 510 "../src/baobab-window.vala"
	_tmp9_ = self->priv->treemap_chart;
#line 510 "../src/baobab-window.vala"
	baobab_chart_set_tree_root (_tmp9_, path);
#line 511 "../src/baobab-window.vala"
	_tmp10_ = self->priv->folder_display;
#line 511 "../src/baobab-window.vala"
	baobab_folder_display_set_path (_tmp10_, path);
#line 512 "../src/baobab-window.vala"
	_tmp11_ = self->priv->pathbar;
#line 512 "../src/baobab-window.vala"
	baobab_pathbar_set_path (_tmp11_, path);
#line 514 "../src/baobab-window.vala"
	_tmp12_ = self->priv->active_location;
#line 514 "../src/baobab-window.vala"
	_tmp13_ = baobab_location_get_scanner (_tmp12_);
#line 514 "../src/baobab-window.vala"
	_tmp14_ = _tmp13_;
#line 514 "../src/baobab-window.vala"
	_tmp15_ = (GtkTreeModelFilter*) gtk_tree_model_filter_new ((GtkTreeModel*) _tmp14_, path);
#line 514 "../src/baobab-window.vala"
	filter = _tmp15_;
#line 515 "../src/baobab-window.vala"
	_tmp16_ = self->priv->treeview;
#line 515 "../src/baobab-window.vala"
	_tmp17_ = filter;
#line 515 "../src/baobab-window.vala"
	_tmp18_ = (GtkTreeModelSort*) gtk_tree_model_sort_new_with_model ((GtkTreeModel*) _tmp17_);
#line 515 "../src/baobab-window.vala"
	_tmp19_ = _tmp18_;
#line 515 "../src/baobab-window.vala"
	gtk_tree_view_set_model (_tmp16_, (GtkTreeModel*) _tmp19_);
#line 515 "../src/baobab-window.vala"
	_g_object_unref0 (_tmp19_);
#line 516 "../src/baobab-window.vala"
	baobab_window_reset_treeview_sorting (self);
#line 518 "../src/baobab-window.vala"
	if (select_first) {
#line 2947 "baobab-window.c"
		GtkTreeView* _tmp20_;
		GtkTreePath* _tmp21_;
		GtkTreePath* _tmp22_;
#line 519 "../src/baobab-window.vala"
		_tmp20_ = self->priv->treeview;
#line 519 "../src/baobab-window.vala"
		_tmp21_ = gtk_tree_path_new_first ();
#line 519 "../src/baobab-window.vala"
		_tmp22_ = _tmp21_;
#line 519 "../src/baobab-window.vala"
		gtk_tree_view_set_cursor (_tmp20_, _tmp22_, NULL, FALSE);
#line 519 "../src/baobab-window.vala"
		__vala_GtkTreePath_free0 (_tmp22_);
#line 2961 "baobab-window.c"
	}
#line 502 "../src/baobab-window.vala"
	_g_object_unref0 (filter);
#line 2965 "baobab-window.c"
}

static void
baobab_window_message (BaobabWindow* self,
                       const gchar* primary_msg,
                       const gchar* secondary_msg,
                       GtkMessageType type)
{
	GtkInfoBar* _tmp0_;
	GtkLabel* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkLabel* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GtkInfoBar* _tmp7_;
#line 523 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 523 "../src/baobab-window.vala"
	g_return_if_fail (primary_msg != NULL);
#line 523 "../src/baobab-window.vala"
	g_return_if_fail (secondary_msg != NULL);
#line 524 "../src/baobab-window.vala"
	_tmp0_ = self->priv->infobar;
#line 524 "../src/baobab-window.vala"
	gtk_info_bar_set_message_type (_tmp0_, type);
#line 525 "../src/baobab-window.vala"
	_tmp1_ = self->priv->infobar_primary_label;
#line 525 "../src/baobab-window.vala"
	_tmp2_ = g_strdup_printf ("<b>%s</b>", primary_msg);
#line 525 "../src/baobab-window.vala"
	_tmp3_ = _tmp2_;
#line 525 "../src/baobab-window.vala"
	gtk_label_set_label (_tmp1_, _tmp3_);
#line 525 "../src/baobab-window.vala"
	_g_free0 (_tmp3_);
#line 526 "../src/baobab-window.vala"
	_tmp4_ = self->priv->infobar_secondary_label;
#line 526 "../src/baobab-window.vala"
	_tmp5_ = g_strdup_printf ("<small>%s</small>", secondary_msg);
#line 526 "../src/baobab-window.vala"
	_tmp6_ = _tmp5_;
#line 526 "../src/baobab-window.vala"
	gtk_label_set_label (_tmp4_, _tmp6_);
#line 526 "../src/baobab-window.vala"
	_g_free0 (_tmp6_);
#line 527 "../src/baobab-window.vala"
	_tmp7_ = self->priv->infobar;
#line 527 "../src/baobab-window.vala"
	gtk_widget_show ((GtkWidget*) _tmp7_);
#line 3016 "baobab-window.c"
}

static void
baobab_window_clear_message (BaobabWindow* self)
{
	GtkInfoBar* _tmp0_;
#line 530 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 531 "../src/baobab-window.vala"
	_tmp0_ = self->priv->infobar;
#line 531 "../src/baobab-window.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 3029 "baobab-window.c"
}

static void
baobab_window_set_busy (BaobabWindow* self,
                        gboolean busy)
{
	GdkCursor* new_cursor = NULL;
	GdkCursor* _tmp12_;
#line 534 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 535 "../src/baobab-window.vala"
	new_cursor = NULL;
#line 536 "../src/baobab-window.vala"
	self->priv->is_busy = busy;
#line 538 "../src/baobab-window.vala"
	if (busy) {
#line 3046 "baobab-window.c"
		GdkCursor* _tmp0_;
		GdkCursor* _tmp1_;
		GtkStackSwitcher* _tmp2_;
		GtkStack* _tmp3_;
		GtkSpinner* _tmp4_;
		GtkSpinner* _tmp5_;
		BaobabPathbar* _tmp6_;
#line 539 "../src/baobab-window.vala"
		_tmp0_ = baobab_window_busy_cursor;
#line 539 "../src/baobab-window.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 539 "../src/baobab-window.vala"
		_g_object_unref0 (new_cursor);
#line 539 "../src/baobab-window.vala"
		new_cursor = _tmp1_;
#line 540 "../src/baobab-window.vala"
		_tmp2_ = self->priv->chart_stack_switcher;
#line 540 "../src/baobab-window.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, FALSE);
#line 541 "../src/baobab-window.vala"
		_tmp3_ = self->priv->spinner_stack;
#line 541 "../src/baobab-window.vala"
		_tmp4_ = self->priv->spinner;
#line 541 "../src/baobab-window.vala"
		gtk_stack_set_visible_child (_tmp3_, (GtkWidget*) _tmp4_);
#line 542 "../src/baobab-window.vala"
		_tmp5_ = self->priv->spinner;
#line 542 "../src/baobab-window.vala"
		gtk_spinner_start (_tmp5_);
#line 543 "../src/baobab-window.vala"
		_tmp6_ = self->priv->pathbar;
#line 543 "../src/baobab-window.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, FALSE);
#line 3080 "baobab-window.c"
	} else {
		GtkSpinner* _tmp7_;
		GtkStack* _tmp8_;
		GtkStack* _tmp9_;
		GtkStackSwitcher* _tmp10_;
		BaobabPathbar* _tmp11_;
#line 545 "../src/baobab-window.vala"
		_tmp7_ = self->priv->spinner;
#line 545 "../src/baobab-window.vala"
		gtk_spinner_stop (_tmp7_);
#line 546 "../src/baobab-window.vala"
		_tmp8_ = self->priv->spinner_stack;
#line 546 "../src/baobab-window.vala"
		_tmp9_ = self->priv->chart_stack;
#line 546 "../src/baobab-window.vala"
		gtk_stack_set_visible_child (_tmp8_, (GtkWidget*) _tmp9_);
#line 547 "../src/baobab-window.vala"
		_tmp10_ = self->priv->chart_stack_switcher;
#line 547 "../src/baobab-window.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, TRUE);
#line 548 "../src/baobab-window.vala"
		_tmp11_ = self->priv->pathbar;
#line 548 "../src/baobab-window.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp11_, TRUE);
#line 3105 "baobab-window.c"
	}
#line 551 "../src/baobab-window.vala"
	_tmp12_ = new_cursor;
#line 551 "../src/baobab-window.vala"
	gtk_widget_set_cursor ((GtkWidget*) self, _tmp12_);
#line 3111 "baobab-window.c"
	{
		BaobabWindowActionState* action_state_collection = NULL;
		gint action_state_collection_length1 = 0;
		gint _action_state_collection_size_ = 0;
		gint action_state_it = 0;
#line 553 "../src/baobab-window.vala"
		action_state_collection = BAOBAB_WINDOW_actions_while_scanning;
#line 553 "../src/baobab-window.vala"
		action_state_collection_length1 = G_N_ELEMENTS (BAOBAB_WINDOW_actions_while_scanning);
#line 553 "../src/baobab-window.vala"
		for (action_state_it = 0; action_state_it < action_state_collection_length1; action_state_it = action_state_it + 1) {
#line 3123 "baobab-window.c"
			BaobabWindowActionState _tmp13_;
			BaobabWindowActionState _tmp14_ = {0};
			BaobabWindowActionState action_state = {0};
#line 553 "../src/baobab-window.vala"
			_tmp13_ = action_state_collection[action_state_it];
#line 553 "../src/baobab-window.vala"
			baobab_window_action_state_copy (&_tmp13_, &_tmp14_);
#line 553 "../src/baobab-window.vala"
			action_state = _tmp14_;
#line 3133 "baobab-window.c"
			{
				GSimpleAction* action = NULL;
				BaobabWindowActionState _tmp15_;
				const gchar* _tmp16_;
				GAction* _tmp17_;
				GSimpleAction* _tmp18_;
				GSimpleAction* _tmp19_;
				BaobabWindowActionState _tmp20_;
#line 554 "../src/baobab-window.vala"
				_tmp15_ = action_state;
#line 554 "../src/baobab-window.vala"
				_tmp16_ = _tmp15_.name;
#line 554 "../src/baobab-window.vala"
				_tmp17_ = g_action_map_lookup_action ((GActionMap*) self, _tmp16_);
#line 554 "../src/baobab-window.vala"
				_tmp18_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp17_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp17_) : NULL);
#line 554 "../src/baobab-window.vala"
				action = _tmp18_;
#line 555 "../src/baobab-window.vala"
				_tmp19_ = action;
#line 555 "../src/baobab-window.vala"
				_tmp20_ = action_state;
#line 555 "../src/baobab-window.vala"
				g_simple_action_set_enabled (_tmp19_, busy == _tmp20_.enable);
#line 553 "../src/baobab-window.vala"
				_g_object_unref0 (action);
#line 553 "../src/baobab-window.vala"
				baobab_window_action_state_destroy (&action_state);
#line 3162 "baobab-window.c"
			}
		}
	}
#line 534 "../src/baobab-window.vala"
	_g_object_unref0 (new_cursor);
#line 3168 "baobab-window.c"
}

static void
baobab_window_set_ui_state (BaobabWindow* self,
                            GtkWidget* child,
                            gboolean busy)
{
	GtkMenuButton* _tmp0_;
	GtkWidget* _tmp1_;
	GtkButton* _tmp2_;
	GtkWidget* _tmp3_;
	GtkButton* _tmp4_;
	GtkWidget* _tmp5_;
	AdwHeaderBar* _tmp6_;
	GtkWidget* _tmp7_;
	GtkStack* _tmp20_;
#line 559 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 559 "../src/baobab-window.vala"
	g_return_if_fail (child != NULL);
#line 560 "../src/baobab-window.vala"
	_tmp0_ = self->priv->menu_button;
#line 560 "../src/baobab-window.vala"
	_tmp1_ = self->priv->home_page;
#line 560 "../src/baobab-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, child == _tmp1_);
#line 561 "../src/baobab-window.vala"
	_tmp2_ = self->priv->reload_button;
#line 561 "../src/baobab-window.vala"
	_tmp3_ = self->priv->result_page;
#line 561 "../src/baobab-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp2_, child == _tmp3_);
#line 562 "../src/baobab-window.vala"
	_tmp4_ = self->priv->back_button;
#line 562 "../src/baobab-window.vala"
	_tmp5_ = self->priv->result_page;
#line 562 "../src/baobab-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp4_, child == _tmp5_);
#line 564 "../src/baobab-window.vala"
	baobab_window_set_busy (self, busy);
#line 566 "../src/baobab-window.vala"
	_tmp6_ = self->priv->header_bar;
#line 566 "../src/baobab-window.vala"
	adw_header_bar_set_title_widget (_tmp6_, NULL);
#line 567 "../src/baobab-window.vala"
	_tmp7_ = self->priv->home_page;
#line 567 "../src/baobab-window.vala"
	if (child == _tmp7_) {
#line 3217 "baobab-window.c"
		GSimpleAction* action = NULL;
		GAction* _tmp8_;
		GSimpleAction* _tmp9_;
		GSimpleAction* _tmp10_;
#line 568 "../src/baobab-window.vala"
		_tmp8_ = g_action_map_lookup_action ((GActionMap*) self, "reload");
#line 568 "../src/baobab-window.vala"
		_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp8_) : NULL);
#line 568 "../src/baobab-window.vala"
		action = _tmp9_;
#line 569 "../src/baobab-window.vala"
		_tmp10_ = action;
#line 569 "../src/baobab-window.vala"
		g_simple_action_set_enabled (_tmp10_, FALSE);
#line 570 "../src/baobab-window.vala"
		gtk_window_set_title ((GtkWindow*) self, _ ("Devices & Locations"));
#line 567 "../src/baobab-window.vala"
		_g_object_unref0 (action);
#line 3236 "baobab-window.c"
	} else {
		GSimpleAction* action = NULL;
		GAction* _tmp11_;
		GSimpleAction* _tmp12_;
		GSimpleAction* _tmp13_;
		BaobabLocation* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		GtkWidget* _tmp17_;
#line 572 "../src/baobab-window.vala"
		_tmp11_ = g_action_map_lookup_action ((GActionMap*) self, "reload");
#line 572 "../src/baobab-window.vala"
		_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp11_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp11_) : NULL);
#line 572 "../src/baobab-window.vala"
		action = _tmp12_;
#line 573 "../src/baobab-window.vala"
		_tmp13_ = action;
#line 573 "../src/baobab-window.vala"
		g_simple_action_set_enabled (_tmp13_, TRUE);
#line 574 "../src/baobab-window.vala"
		_tmp14_ = self->priv->active_location;
#line 574 "../src/baobab-window.vala"
		_tmp15_ = baobab_location_get_name (_tmp14_);
#line 574 "../src/baobab-window.vala"
		_tmp16_ = _tmp15_;
#line 574 "../src/baobab-window.vala"
		gtk_window_set_title ((GtkWindow*) self, _tmp16_);
#line 575 "../src/baobab-window.vala"
		_tmp17_ = self->priv->result_page;
#line 575 "../src/baobab-window.vala"
		if (child == _tmp17_) {
#line 3268 "baobab-window.c"
			AdwHeaderBar* _tmp18_;
			BaobabPathbar* _tmp19_;
#line 576 "../src/baobab-window.vala"
			_tmp18_ = self->priv->header_bar;
#line 576 "../src/baobab-window.vala"
			_tmp19_ = self->priv->pathbar;
#line 576 "../src/baobab-window.vala"
			adw_header_bar_set_title_widget (_tmp18_, (GtkWidget*) _tmp19_);
#line 3277 "baobab-window.c"
		}
#line 567 "../src/baobab-window.vala"
		_g_object_unref0 (action);
#line 3281 "baobab-window.c"
	}
#line 580 "../src/baobab-window.vala"
	_tmp20_ = self->priv->main_stack;
#line 580 "../src/baobab-window.vala"
	gtk_stack_set_visible_child (_tmp20_, child);
#line 3287 "baobab-window.c"
}

static void
baobab_window_set_chart_location (BaobabWindow* self,
                                  BaobabLocation* location)
{
	BaobabChart* _tmp0_;
	BaobabChart* _tmp1_;
#line 598 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 598 "../src/baobab-window.vala"
	g_return_if_fail (location != NULL);
#line 599 "../src/baobab-window.vala"
	_tmp0_ = self->priv->rings_chart;
#line 599 "../src/baobab-window.vala"
	baobab_chart_set_location (_tmp0_, location);
#line 600 "../src/baobab-window.vala"
	_tmp1_ = self->priv->treemap_chart;
#line 600 "../src/baobab-window.vala"
	baobab_chart_set_location (_tmp1_, location);
#line 3308 "baobab-window.c"
}

static void
baobab_window_scanner_completed (BaobabWindow* self)
{
	BaobabScanner* scanner = NULL;
	BaobabLocation* _tmp0_;
	BaobabScanner* _tmp1_;
	BaobabScanner* _tmp2_;
	BaobabScanner* _tmp3_;
	GtkTreePath* _tmp17_;
	GtkTreePath* _tmp18_;
	BaobabLocation* _tmp19_;
	GtkWidget* _tmp20_;
	BaobabFolderDisplay* _tmp21_;
	GtkTreePath* _tmp22_;
	GtkTreePath* _tmp23_;
	BaobabScanner* _tmp24_;
	gboolean _tmp25_;
	gboolean _tmp26_;
	gboolean _tmp27_;
	gboolean _tmp28_;
	GError* _inner_error0_ = NULL;
#line 603 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 604 "../src/baobab-window.vala"
	_tmp0_ = self->priv->active_location;
#line 604 "../src/baobab-window.vala"
	_tmp1_ = baobab_location_get_scanner (_tmp0_);
#line 604 "../src/baobab-window.vala"
	_tmp2_ = _tmp1_;
#line 604 "../src/baobab-window.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 604 "../src/baobab-window.vala"
	scanner = _tmp3_;
#line 606 "../src/baobab-window.vala"
	if (self->priv->scan_completed_handler > ((gulong) 0)) {
#line 3346 "baobab-window.c"
		BaobabScanner* _tmp4_;
#line 607 "../src/baobab-window.vala"
		_tmp4_ = scanner;
#line 607 "../src/baobab-window.vala"
		g_signal_handler_disconnect ((GObject*) _tmp4_, self->priv->scan_completed_handler);
#line 608 "../src/baobab-window.vala"
		self->priv->scan_completed_handler = (gulong) 0;
#line 3354 "baobab-window.c"
	}
#line 611 "../src/baobab-window.vala"
	if (self->priv->scanning_progress_id > ((guint) 0)) {
#line 612 "../src/baobab-window.vala"
		g_source_remove (self->priv->scanning_progress_id);
#line 613 "../src/baobab-window.vala"
		self->priv->scanning_progress_id = (guint) 0;
#line 3362 "baobab-window.c"
	}
	{
		BaobabScanner* _tmp5_;
#line 617 "../src/baobab-window.vala"
		_tmp5_ = scanner;
#line 617 "../src/baobab-window.vala"
		baobab_scanner_finish (_tmp5_, &_inner_error0_);
#line 617 "../src/baobab-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 617 "../src/baobab-window.vala"
			if (g_error_matches (_inner_error0_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 3374 "baobab-window.c"
				goto __catch0_g_io_error_cancelled;
			}
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_io_error_cancelled:
	{
#line 616 "../src/baobab-window.vala"
		g_clear_error (&_inner_error0_);
#line 620 "../src/baobab-window.vala"
		_g_object_unref0 (scanner);
#line 620 "../src/baobab-window.vala"
		return;
#line 3389 "baobab-window.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		gchar* primary = NULL;
		BaobabScanner* _tmp6_;
		GFile* _tmp7_;
		GFile* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
		GError* _tmp14_;
		const gchar* _tmp15_;
		GtkWidget* _tmp16_;
#line 616 "../src/baobab-window.vala"
		e = _inner_error0_;
#line 616 "../src/baobab-window.vala"
		_inner_error0_ = NULL;
#line 622 "../src/baobab-window.vala"
		_tmp6_ = scanner;
#line 622 "../src/baobab-window.vala"
		_tmp7_ = baobab_scanner_get_directory (_tmp6_);
#line 622 "../src/baobab-window.vala"
		_tmp8_ = _tmp7_;
#line 622 "../src/baobab-window.vala"
		_tmp9_ = g_file_get_parse_name (_tmp8_);
#line 622 "../src/baobab-window.vala"
		_tmp10_ = _tmp9_;
#line 622 "../src/baobab-window.vala"
		_tmp11_ = g_strdup_printf (_ ("Could not scan folder “%s”"), _tmp10_);
#line 622 "../src/baobab-window.vala"
		_tmp12_ = _tmp11_;
#line 622 "../src/baobab-window.vala"
		_g_free0 (_tmp10_);
#line 622 "../src/baobab-window.vala"
		primary = _tmp12_;
#line 623 "../src/baobab-window.vala"
		_tmp13_ = primary;
#line 623 "../src/baobab-window.vala"
		_tmp14_ = e;
#line 623 "../src/baobab-window.vala"
		_tmp15_ = _tmp14_->message;
#line 623 "../src/baobab-window.vala"
		baobab_window_message (self, _tmp13_, _tmp15_, GTK_MESSAGE_ERROR);
#line 624 "../src/baobab-window.vala"
		_tmp16_ = self->priv->home_page;
#line 624 "../src/baobab-window.vala"
		baobab_window_set_ui_state (self, _tmp16_, FALSE);
#line 625 "../src/baobab-window.vala"
		_g_free0 (primary);
#line 625 "../src/baobab-window.vala"
		_g_error_free0 (e);
#line 625 "../src/baobab-window.vala"
		_g_object_unref0 (scanner);
#line 625 "../src/baobab-window.vala"
		return;
#line 3449 "baobab-window.c"
	}
	__finally0:
#line 616 "../src/baobab-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 616 "../src/baobab-window.vala"
		_g_object_unref0 (scanner);
#line 616 "../src/baobab-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 616 "../src/baobab-window.vala"
		g_clear_error (&_inner_error0_);
#line 616 "../src/baobab-window.vala"
		return;
#line 3462 "baobab-window.c"
	}
#line 628 "../src/baobab-window.vala"
	_tmp17_ = gtk_tree_path_new_first ();
#line 628 "../src/baobab-window.vala"
	_tmp18_ = _tmp17_;
#line 628 "../src/baobab-window.vala"
	baobab_window_reroot_treeview (self, _tmp18_, FALSE);
#line 628 "../src/baobab-window.vala"
	__vala_GtkTreePath_free0 (_tmp18_);
#line 629 "../src/baobab-window.vala"
	_tmp19_ = self->priv->active_location;
#line 629 "../src/baobab-window.vala"
	baobab_window_set_chart_location (self, _tmp19_);
#line 630 "../src/baobab-window.vala"
	_tmp20_ = self->priv->result_page;
#line 630 "../src/baobab-window.vala"
	baobab_window_set_ui_state (self, _tmp20_, FALSE);
#line 633 "../src/baobab-window.vala"
	_tmp21_ = self->priv->folder_display;
#line 633 "../src/baobab-window.vala"
	_tmp22_ = gtk_tree_path_new_first ();
#line 633 "../src/baobab-window.vala"
	_tmp23_ = _tmp22_;
#line 633 "../src/baobab-window.vala"
	baobab_folder_display_set_path (_tmp21_, _tmp23_);
#line 633 "../src/baobab-window.vala"
	__vala_GtkTreePath_free0 (_tmp23_);
#line 634 "../src/baobab-window.vala"
	baobab_window_copy_treeview_column_sizes (self);
#line 636 "../src/baobab-window.vala"
	_tmp24_ = scanner;
#line 636 "../src/baobab-window.vala"
	_tmp25_ = baobab_scanner_get_show_allocated_size (_tmp24_);
#line 636 "../src/baobab-window.vala"
	_tmp26_ = _tmp25_;
#line 636 "../src/baobab-window.vala"
	if (!_tmp26_) {
#line 637 "../src/baobab-window.vala"
		baobab_window_message (self, _ ("Could not always detect occupied disk sizes."), _ ("Apparent sizes may be shown instead."), GTK_MESSAGE_INFO);
#line 3502 "baobab-window.c"
	}
#line 640 "../src/baobab-window.vala"
	g_object_get ((GtkWindow*) self, "is-active", &_tmp27_, NULL);
#line 640 "../src/baobab-window.vala"
	_tmp28_ = _tmp27_;
#line 640 "../src/baobab-window.vala"
	if (!_tmp28_) {
#line 3510 "baobab-window.c"
		GNotification* notification = NULL;
		GNotification* _tmp29_;
		GNotification* _tmp30_;
		BaobabScanner* _tmp31_;
		GFile* _tmp32_;
		GFile* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		GtkApplication* _tmp38_;
		GNotification* _tmp39_;
#line 641 "../src/baobab-window.vala"
		_tmp29_ = g_notification_new (_ ("Scan completed"));
#line 641 "../src/baobab-window.vala"
		notification = _tmp29_;
#line 642 "../src/baobab-window.vala"
		_tmp30_ = notification;
#line 642 "../src/baobab-window.vala"
		_tmp31_ = scanner;
#line 642 "../src/baobab-window.vala"
		_tmp32_ = baobab_scanner_get_directory (_tmp31_);
#line 642 "../src/baobab-window.vala"
		_tmp33_ = _tmp32_;
#line 642 "../src/baobab-window.vala"
		_tmp34_ = g_file_get_parse_name (_tmp33_);
#line 642 "../src/baobab-window.vala"
		_tmp35_ = _tmp34_;
#line 642 "../src/baobab-window.vala"
		_tmp36_ = g_strdup_printf (_ ("Completed scan of “%s”"), _tmp35_);
#line 642 "../src/baobab-window.vala"
		_tmp37_ = _tmp36_;
#line 642 "../src/baobab-window.vala"
		g_notification_set_body (_tmp30_, _tmp37_);
#line 642 "../src/baobab-window.vala"
		_g_free0 (_tmp37_);
#line 642 "../src/baobab-window.vala"
		_g_free0 (_tmp35_);
#line 643 "../src/baobab-window.vala"
		_tmp38_ = gtk_window_get_application ((GtkWindow*) self);
#line 643 "../src/baobab-window.vala"
		_tmp39_ = notification;
#line 643 "../src/baobab-window.vala"
		g_application_send_notification ((GApplication*) _tmp38_, "scan-completed", _tmp39_);
#line 640 "../src/baobab-window.vala"
		_g_object_unref0 (notification);
#line 3557 "baobab-window.c"
	}
#line 603 "../src/baobab-window.vala"
	_g_object_unref0 (scanner);
#line 3561 "baobab-window.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 647 "../src/baobab-window.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 647 "../src/baobab-window.vala"
	return _data9_;
#line 3571 "baobab-window.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 647 "../src/baobab-window.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 3581 "baobab-window.c"
		BaobabWindow* self;
#line 647 "../src/baobab-window.vala"
		self = _data9_->self;
#line 647 "../src/baobab-window.vala"
		_baobab_location_unref0 (_data9_->location);
#line 647 "../src/baobab-window.vala"
		_g_object_unref0 (self);
#line 647 "../src/baobab-window.vala"
		g_slice_free (Block9Data, _data9_);
#line 3591 "baobab-window.c"
	}
}

static void
_baobab_window_scanner_completed_baobab_scanner_completed (BaobabScanner* _sender,
                                                           gpointer self)
{
#line 661 "../src/baobab-window.vala"
	baobab_window_scanner_completed ((BaobabWindow*) self);
#line 3601 "baobab-window.c"
}

static gboolean
__lambda17_ (Block9Data* _data9_)
{
	BaobabWindow* self;
	gboolean result;
#line 665 "../src/baobab-window.vala"
	self = _data9_->self;
#line 666 "../src/baobab-window.vala"
	g_signal_emit_by_name (_data9_->location, "progress");
#line 667 "../src/baobab-window.vala"
	result = G_SOURCE_CONTINUE;
#line 667 "../src/baobab-window.vala"
	return result;
#line 3617 "baobab-window.c"
}

static gboolean
___lambda17__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda17_ (self);
#line 665 "../src/baobab-window.vala"
	return result;
#line 3627 "baobab-window.c"
}

static void
baobab_window_scan_location (BaobabWindow* self,
                             BaobabLocation* location,
                             gboolean force)
{
	Block9Data* _data9_;
	BaobabLocation* _tmp0_;
	BaobabLocation* _tmp1_;
	BaobabPathbar* _tmp2_;
	BaobabFolderDisplay* _tmp3_;
	BaobabLocationList* _tmp4_;
	GtkTreeView* _tmp5_;
	BaobabScanner* scanner = NULL;
	BaobabScanner* _tmp6_;
	BaobabScanner* _tmp7_;
	BaobabScanner* _tmp8_;
	gulong _tmp9_;
	GtkWidget* _tmp10_;
#line 647 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 647 "../src/baobab-window.vala"
	g_return_if_fail (location != NULL);
#line 647 "../src/baobab-window.vala"
	_data9_ = g_slice_new0 (Block9Data);
#line 647 "../src/baobab-window.vala"
	_data9_->_ref_count_ = 1;
#line 647 "../src/baobab-window.vala"
	_data9_->self = g_object_ref (self);
#line 647 "../src/baobab-window.vala"
	_tmp0_ = _baobab_location_ref0 (location);
#line 647 "../src/baobab-window.vala"
	_baobab_location_unref0 (_data9_->location);
#line 647 "../src/baobab-window.vala"
	_data9_->location = _tmp0_;
#line 648 "../src/baobab-window.vala"
	baobab_window_cancel_scan (self);
#line 650 "../src/baobab-window.vala"
	_tmp1_ = _baobab_location_ref0 (_data9_->location);
#line 650 "../src/baobab-window.vala"
	_baobab_location_unref0 (self->priv->active_location);
#line 650 "../src/baobab-window.vala"
	self->priv->active_location = _tmp1_;
#line 652 "../src/baobab-window.vala"
	_tmp2_ = self->priv->pathbar;
#line 652 "../src/baobab-window.vala"
	baobab_pathbar_set_location (_tmp2_, _data9_->location);
#line 653 "../src/baobab-window.vala"
	_tmp3_ = self->priv->folder_display;
#line 653 "../src/baobab-window.vala"
	baobab_folder_display_set_location (_tmp3_, _data9_->location);
#line 656 "../src/baobab-window.vala"
	_tmp4_ = self->priv->location_list;
#line 656 "../src/baobab-window.vala"
	baobab_location_list_add_location (_tmp4_, _data9_->location);
#line 658 "../src/baobab-window.vala"
	_tmp5_ = self->priv->treeview;
#line 658 "../src/baobab-window.vala"
	gtk_tree_view_set_model (_tmp5_, NULL);
#line 660 "../src/baobab-window.vala"
	_tmp6_ = baobab_location_get_scanner (_data9_->location);
#line 660 "../src/baobab-window.vala"
	_tmp7_ = _tmp6_;
#line 660 "../src/baobab-window.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 660 "../src/baobab-window.vala"
	scanner = _tmp8_;
#line 661 "../src/baobab-window.vala"
	_tmp9_ = g_signal_connect_object (scanner, "completed", (GCallback) _baobab_window_scanner_completed_baobab_scanner_completed, self, 0);
#line 661 "../src/baobab-window.vala"
	self->priv->scan_completed_handler = _tmp9_;
#line 663 "../src/baobab-window.vala"
	baobab_window_clear_message (self);
#line 665 "../src/baobab-window.vala"
	self->priv->scanning_progress_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, ___lambda17__gsource_func, block9_data_ref (_data9_), block9_data_unref);
#line 670 "../src/baobab-window.vala"
	_tmp10_ = self->priv->result_page;
#line 670 "../src/baobab-window.vala"
	baobab_window_set_ui_state (self, _tmp10_, TRUE);
#line 671 "../src/baobab-window.vala"
	baobab_scanner_scan (scanner, force);
#line 647 "../src/baobab-window.vala"
	_g_object_unref0 (scanner);
#line 647 "../src/baobab-window.vala"
	block9_data_unref (_data9_);
#line 647 "../src/baobab-window.vala"
	_data9_ = NULL;
#line 3716 "baobab-window.c"
}

void
baobab_window_scan_directory (BaobabWindow* self,
                              GFile* directory,
                              BaobabScanFlags flags)
{
	GFileInfo* info = NULL;
	gboolean _tmp3_ = FALSE;
	GFileInfo* _tmp4_;
	BaobabLocation* location = NULL;
	BaobabLocation* _tmp11_;
	BaobabLocation* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 674 "../src/baobab-window.vala"
	g_return_if_fail (self != NULL);
#line 674 "../src/baobab-window.vala"
	g_return_if_fail (directory != NULL);
#line 675 "../src/baobab-window.vala"
	info = NULL;
#line 3737 "baobab-window.c"
	{
		GFileInfo* _tmp0_ = NULL;
		GFileInfo* _tmp1_;
		GFileInfo* _tmp2_;
#line 677 "../src/baobab-window.vala"
		_tmp1_ = g_file_query_info (directory, G_FILE_ATTRIBUTE_STANDARD_TYPE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 677 "../src/baobab-window.vala"
		_tmp0_ = _tmp1_;
#line 677 "../src/baobab-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3748 "baobab-window.c"
			goto __catch0_g_error;
		}
#line 677 "../src/baobab-window.vala"
		_tmp2_ = _tmp0_;
#line 677 "../src/baobab-window.vala"
		_tmp0_ = NULL;
#line 677 "../src/baobab-window.vala"
		_g_object_unref0 (info);
#line 677 "../src/baobab-window.vala"
		info = _tmp2_;
#line 676 "../src/baobab-window.vala"
		_g_object_unref0 (_tmp0_);
#line 3761 "baobab-window.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 676 "../src/baobab-window.vala"
		g_clear_error (&_inner_error0_);
#line 3768 "baobab-window.c"
	}
	__finally0:
#line 676 "../src/baobab-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 676 "../src/baobab-window.vala"
		_g_object_unref0 (info);
#line 676 "../src/baobab-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 676 "../src/baobab-window.vala"
		g_clear_error (&_inner_error0_);
#line 676 "../src/baobab-window.vala"
		return;
#line 3781 "baobab-window.c"
	}
#line 681 "../src/baobab-window.vala"
	_tmp4_ = info;
#line 681 "../src/baobab-window.vala"
	if (_tmp4_ == NULL) {
#line 681 "../src/baobab-window.vala"
		_tmp3_ = TRUE;
#line 3789 "baobab-window.c"
	} else {
		GFileInfo* _tmp5_;
#line 681 "../src/baobab-window.vala"
		_tmp5_ = info;
#line 681 "../src/baobab-window.vala"
		_tmp3_ = g_file_info_get_file_type (_tmp5_) != G_FILE_TYPE_DIRECTORY;
#line 3796 "baobab-window.c"
	}
#line 681 "../src/baobab-window.vala"
	if (_tmp3_) {
#line 3800 "baobab-window.c"
		gchar* primary = NULL;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		const gchar* _tmp10_;
#line 682 "../src/baobab-window.vala"
		_tmp6_ = g_file_get_parse_name (directory);
#line 682 "../src/baobab-window.vala"
		_tmp7_ = _tmp6_;
#line 682 "../src/baobab-window.vala"
		_tmp8_ = g_strdup_printf (_ ("“%s” is not a valid folder"), _tmp7_);
#line 682 "../src/baobab-window.vala"
		_tmp9_ = _tmp8_;
#line 682 "../src/baobab-window.vala"
		_g_free0 (_tmp7_);
#line 682 "../src/baobab-window.vala"
		primary = _tmp9_;
#line 683 "../src/baobab-window.vala"
		_tmp10_ = primary;
#line 683 "../src/baobab-window.vala"
		baobab_window_message (self, _tmp10_, _ ("Could not analyze disk usage."), GTK_MESSAGE_ERROR);
#line 684 "../src/baobab-window.vala"
		_g_free0 (primary);
#line 684 "../src/baobab-window.vala"
		_g_object_unref0 (info);
#line 684 "../src/baobab-window.vala"
		return;
#line 3829 "baobab-window.c"
	}
#line 687 "../src/baobab-window.vala"
	_tmp11_ = baobab_location_new_for_file (directory, flags);
#line 687 "../src/baobab-window.vala"
	location = _tmp11_;
#line 688 "../src/baobab-window.vala"
	_tmp12_ = location;
#line 688 "../src/baobab-window.vala"
	baobab_window_scan_location (self, _tmp12_, FALSE);
#line 674 "../src/baobab-window.vala"
	_baobab_location_unref0 (location);
#line 674 "../src/baobab-window.vala"
	_g_object_unref0 (info);
#line 3843 "baobab-window.c"
}

void
baobab_window_action_state_copy (const BaobabWindowActionState* self,
                                 BaobabWindowActionState* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 113 "../src/baobab-window.vala"
	_tmp0_ = (*self).name;
#line 113 "../src/baobab-window.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 113 "../src/baobab-window.vala"
	_g_free0 ((*dest).name);
#line 113 "../src/baobab-window.vala"
	(*dest).name = _tmp1_;
#line 113 "../src/baobab-window.vala"
	(*dest).enable = (*self).enable;
#line 3862 "baobab-window.c"
}

void
baobab_window_action_state_destroy (BaobabWindowActionState* self)
{
#line 114 "../src/baobab-window.vala"
	_g_free0 ((*self).name);
#line 3870 "baobab-window.c"
}

BaobabWindowActionState*
baobab_window_action_state_dup (const BaobabWindowActionState* self)
{
	BaobabWindowActionState* dup;
#line 113 "../src/baobab-window.vala"
	dup = g_new0 (BaobabWindowActionState, 1);
#line 113 "../src/baobab-window.vala"
	baobab_window_action_state_copy (self, dup);
#line 113 "../src/baobab-window.vala"
	return dup;
#line 3883 "baobab-window.c"
}

void
baobab_window_action_state_free (BaobabWindowActionState* self)
{
#line 113 "../src/baobab-window.vala"
	baobab_window_action_state_destroy (self);
#line 113 "../src/baobab-window.vala"
	g_free (self);
#line 3893 "baobab-window.c"
}

static GType
baobab_window_action_state_get_type_once (void)
{
	GType baobab_window_action_state_type_id;
	baobab_window_action_state_type_id = g_boxed_type_register_static ("BaobabWindowActionState", (GBoxedCopyFunc) baobab_window_action_state_dup, (GBoxedFreeFunc) baobab_window_action_state_free);
	return baobab_window_action_state_type_id;
}

GType
baobab_window_action_state_get_type (void)
{
	static volatile gsize baobab_window_action_state_type_id__once = 0;
	if (g_once_init_enter (&baobab_window_action_state_type_id__once)) {
		GType baobab_window_action_state_type_id;
		baobab_window_action_state_type_id = baobab_window_action_state_get_type_once ();
		g_once_init_leave (&baobab_window_action_state_type_id__once, baobab_window_action_state_type_id);
	}
	return baobab_window_action_state_type_id__once;
}

static void
baobab_window_class_init (BaobabWindowClass * klass,
                          gpointer klass_data)
{
#line 26 "../src/baobab-window.vala"
	baobab_window_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/baobab-window.vala"
	g_type_class_adjust_private_offset (klass, &BaobabWindow_private_offset);
#line 26 "../src/baobab-window.vala"
	G_OBJECT_CLASS (klass)->finalize = baobab_window_finalize;
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/baobab/ui/baobab-main-window.ui");
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "focus_controller", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, focus_controller));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "drop_target", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, drop_target));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "back_gesture", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, back_gesture));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "vbox", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, vbox));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "header_bar", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, header_bar));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "pathbar", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, pathbar));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "back_button", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, back_button));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "reload_button", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, reload_button));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "menu_button", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, menu_button));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "main_stack", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, main_stack));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "home_page", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, home_page));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "result_page", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, result_page));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "infobar", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, infobar));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "infobar_primary_label", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, infobar_primary_label));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "infobar_secondary_label", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, infobar_secondary_label));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "infobar_close_button", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, infobar_close_button));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "location_list", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, location_list));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "folder_display", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, folder_display));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "treeview", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, treeview));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "treeview_popover_menu", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, treeview_popover_menu));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "size_column", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, size_column));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "contents_column", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, contents_column));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "time_modified_column", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, time_modified_column));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "treeview_right_click_gesture", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, treeview_right_click_gesture));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "chart_stack", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, chart_stack));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "spinner_stack", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, spinner_stack));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "chart_stack_switcher", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, chart_stack_switcher));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "rings_chart", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, rings_chart));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "treemap_chart", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, treemap_chart));
#line 26 "../src/baobab-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "spinner", FALSE, BaobabWindow_private_offset + G_STRUCT_OFFSET (BaobabWindowPrivate, spinner));
#line 3988 "baobab-window.c"
}

static void
baobab_window_instance_init (BaobabWindow * self,
                             gpointer klass)
{
#line 26 "../src/baobab-window.vala"
	self->priv = baobab_window_get_instance_private (self);
#line 88 "../src/baobab-window.vala"
	self->priv->active_location = NULL;
#line 89 "../src/baobab-window.vala"
	self->priv->is_busy = FALSE;
#line 90 "../src/baobab-window.vala"
	self->priv->scan_completed_handler = (gulong) 0;
#line 91 "../src/baobab-window.vala"
	self->priv->scanning_progress_id = (guint) 0;
#line 26 "../src/baobab-window.vala"
	g_type_ensure (BAOBAB_TYPE_PATHBAR);
#line 26 "../src/baobab-window.vala"
	g_type_ensure (BAOBAB_TYPE_LOCATION_LIST);
#line 26 "../src/baobab-window.vala"
	g_type_ensure (BAOBAB_TYPE_FOLDER_DISPLAY);
#line 26 "../src/baobab-window.vala"
	g_type_ensure (BAOBAB_TYPE_CHART);
#line 26 "../src/baobab-window.vala"
	g_type_ensure (BAOBAB_TYPE_CHART);
#line 26 "../src/baobab-window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 4017 "baobab-window.c"
}

static void
baobab_window_finalize (GObject * obj)
{
	BaobabWindow * self;
#line 26 "../src/baobab-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BAOBAB_TYPE_WINDOW, BaobabWindow);
#line 88 "../src/baobab-window.vala"
	_baobab_location_unref0 (self->priv->active_location);
#line 26 "../src/baobab-window.vala"
	G_OBJECT_CLASS (baobab_window_parent_class)->finalize (obj);
#line 4030 "baobab-window.c"
}

static GType
baobab_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BaobabWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) baobab_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BaobabWindow), 0, (GInstanceInitFunc) baobab_window_instance_init, NULL };
	GType baobab_window_type_id;
	baobab_window_type_id = g_type_register_static (adw_application_window_get_type (), "BaobabWindow", &g_define_type_info, 0);
	BaobabWindow_private_offset = g_type_add_instance_private (baobab_window_type_id, sizeof (BaobabWindowPrivate));
	return baobab_window_type_id;
}

GType
baobab_window_get_type (void)
{
	static volatile gsize baobab_window_type_id__once = 0;
	if (g_once_init_enter (&baobab_window_type_id__once)) {
		GType baobab_window_type_id;
		baobab_window_type_id = baobab_window_get_type_once ();
		g_once_init_leave (&baobab_window_type_id__once, baobab_window_type_id);
	}
	return baobab_window_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

